New issue

Have a question about this project? Sign up for a free GitHub account to open an issue and contact its maintainers and the community.

By clicking “Sign up for GitHub”, you agree to our terms of service and privacy statement. We’ll occasionally send you account related emails.

Already on GitHub? Sign in to your account

Let approx() work on more generic sequences #4327

Merged
merged 2 commits into from Dec 17, 2018

Conversation

Projects
None yet
4 participants
@ndevenish
Copy link
Contributor

ndevenish commented Nov 7, 2018

My Problem

approx() was updated in 9f3122f to work better with numpy arrays, however at the same time the requirements were tightened from requiring an Iterable to requiring a Sequence - the former being
tested only on interface, while the latter requires subclassing or registration with the abc.

This broke our code which uses many custom containers (though it wasn't apparent to us that things were broken until the Scalar testing was tightened in cd2085e). For various (mainly political) reasons it's hard to change our code for pytest, and in any case I believe this benefits from a broader solution.

This Patch

Since the ApproxSequence only used __iter__ and __len__ anyway, this patch reduces the requirement to only what's used, and allows unregistered Sequence-like containers to be used. Since numpy arrays qualify for the new criteria, I've reordered the checks so that generic sequences are checked for after numpy arrays (which would also work if numpy every made the arrays officially sequences)

This Code

I know the new test doesn't look as neat as the old one, but thought it better to start out explicit rather than making e.g. a new custom Sequencelike abc which implements __subclasshook__ . Sequence can't be removed from compat.py because is also used for testing in

def issequence(x):
return isinstance(x, Sequence) and not isinstance(x, basestring)
and I haven't investigated whether it's also appropriate to loosen that. I'm happy to do that work if people would require.

I've categorised the changelog as bugfix for now. Also, have followed instructions but unsure if this is large enough to qualify for the step:

  • Add yourself to AUTHORS in alphabetical order;

@ndevenish ndevenish force-pushed the ndevenish:approx branch 2 times, most recently from 2524b43 to 3383823 Nov 7, 2018

@codecov

This comment has been minimized.

Copy link

codecov bot commented Nov 7, 2018

Codecov Report

Merging #4327 into features will increase coverage by 0.05%.
The diff coverage is 100%.

Impacted file tree graph

@@             Coverage Diff              @@
##           features    #4327      +/-   ##
============================================
+ Coverage     95.88%   95.93%   +0.05%     
============================================
  Files           111      111              
  Lines         24997    25537     +540     
  Branches       2442     2537      +95     
============================================
+ Hits          23969    24500     +531     
- Misses          726      731       +5     
- Partials        302      306       +4
Flag Coverage Δ
#docs 30.06% <85.71%> (+0.23%) ⬆️
#doctesting 30.06% <85.71%> (+0.23%) ⬆️
#linting 30.06% <85.71%> (+0.23%) ⬆️
#linux 95.77% <100%> (+0.05%) ⬆️
#nobyte 92.35% <93.33%> (ø) ⬆️
#numpy 91.88% <100%> (-1.26%) ⬇️
#pexpect 41.91% <100%> (+0.15%) ⬆️
#py27 92.76% <93.33%> (-1.27%) ⬇️
#py34 92.17% <93.33%> (+0.06%) ⬆️
#py35 92.18% <93.33%> (+0.06%) ⬆️
#py36 92.2% <93.33%> (+0.06%) ⬆️
#py37 94.18% <93.33%> (+0.09%) ⬆️
#trial 91.88% <100%> (-1.26%) ⬇️
#windows 94.1% <100%> (ø) ⬆️
#xdist 94.01% <100%> (+0.07%) ⬆️
Impacted Files Coverage Δ
src/_pytest/compat.py 96.87% <100%> (ø) ⬆️
src/_pytest/python_api.py 97.43% <100%> (+0.01%) ⬆️
testing/python/approx.py 99.62% <100%> (+0.01%) ⬆️
testing/test_collection.py 99.8% <0%> (ø) ⬆️
src/_pytest/python.py 95.3% <0%> (+0.02%) ⬆️
src/_pytest/assertion/rewrite.py 95.93% <0%> (+0.23%) ⬆️
src/_pytest/config/__init__.py 95.44% <0%> (+0.43%) ⬆️
src/_pytest/capture.py 93.87% <0%> (+0.45%) ⬆️
src/_pytest/terminal.py 93.02% <0%> (+0.85%) ⬆️
testing/test_session.py 98.52% <0%> (+2.01%) ⬆️
... and 2 more

Continue to review full report at Codecov.

Legend - Click here to learn more
Δ = absolute <relative> (impact), ø = not affected, ? = missing data
Powered by Codecov. Last update 62967b3...4eddf63. Read the comment docs.

@ndevenish ndevenish force-pushed the ndevenish:approx branch from 3383823 to d3ed9a6 Nov 7, 2018

@ndevenish

This comment has been minimized.

Copy link
Contributor

ndevenish commented Nov 7, 2018

Note: I realised I both left the AUTHORS change in, and got the order wrong, so fixed and re-pushed. Out of neatness habit I rewrote the main commit, so apologies for the extra work on the CI.

def __len__(self):
return 4

assert [1, 2, 3, 4] == approx(newIterable())

This comment has been minimized.

@RonnyPfannschmidt

RonnyPfannschmidt Nov 7, 2018

Member

i believe his breaks if an approx object is reused - just unpack explicitly

This comment has been minimized.

@ndevenish

ndevenish Nov 18, 2018

Contributor

Not entirely sure what you meant - unless you read the test class as an iterator rather than an iterable? In any case, I've split out the creations, was this what you meant?

https://github.com/pytest-dev/pytest/pull/4327/files#diff-a4d4d6cc8ecc32438c8a4da391852f22R508

@ndevenish

This comment has been minimized.

Copy link
Contributor

ndevenish commented Nov 7, 2018

I've just been reminded that lack of __iter__ doesn't mean that an object isn't iterable, as iter (and thus ranges, loops, comprehensions) will work just as well with __getitem__ only.

So technically the test should be for isinstance(expected, Iterable) or hasattr(expected, '__getitem__'). Or, attempting iter(expected) and catching the exception?

Depends how general this should be?

@nicoddemus

This comment has been minimized.

Copy link
Member

nicoddemus commented Nov 8, 2018

IMHO, isinstance(expected, Iterable) is enough for most cases that we want to support. We may decide to be more general later if needed, but having to be more strict in the future is usually more problematic.

@@ -496,3 +496,13 @@ def test_numpy_scalar_with_array(self):
assert actual != approx(expected, rel=5e-8, abs=0)
assert approx(expected, rel=5e-7, abs=0) == actual
assert approx(expected, rel=5e-8, abs=0) != actual

def test_generic_iterable_sized_object(self):
class newIterable(object):

This comment has been minimized.

@nicoddemus

nicoddemus Nov 8, 2018

Member

I suggest using a My prefix (MyIterable) which is used in a few other places in our tests, and also follows the CamelCase naming convention for classes. 👍

@nicoddemus
Copy link
Member

nicoddemus left a comment

Please also rebase this on features. 👍

@@ -0,0 +1 @@
Loosen the definition of what ``approx`` considers a sequence

This comment has been minimized.

@nicoddemus

nicoddemus Nov 10, 2018

Member

If we have decided this, please specify, I suggest:

``approx`` now works with more generic containers, more precisely instances of ``Iterable`` instead of more restrict ``Sequence``.

This comment has been minimized.

@ndevenish

ndevenish Nov 18, 2018

Contributor

I went for the slightly different

approx again works with more generic containers, more precisely instances of Iterable and Sized instead of more restrictive Sequence.

To emphasises the actual restriction and that it's restoring a previous compatibility

ndevenish added some commits Nov 7, 2018

Let approx() work on more generic sequences
approx() was updated in 9f3122f to work better with numpy arrays,
however at the same time the requirements were tightened from
requiring an Iterable to requiring a Sequence - the former being
tested only on interface, while the latter requires subclassing or
registration with the abc.

Since the ApproxSequence only used __iter__ and __len__ this commit
reduces the requirement to only what's used, and allows unregistered
Sequence-like containers to be used.

Since numpy arrays qualify for the new criteria, reorder the checks so
that generic sequences are checked for after numpy arrays.

@ndevenish ndevenish force-pushed the ndevenish:approx branch from d3ed9a6 to 4eddf63 Nov 18, 2018

@ndevenish ndevenish changed the base branch from master to features Nov 18, 2018

@ndevenish

This comment has been minimized.

Copy link
Contributor

ndevenish commented Nov 18, 2018

Thanks for the comments. I've

  • Changed the declaration of the expected iterable
  • Changed the news fragment to be more precise
  • Changed to be on top of the feature branch (though should I change the news classification to a feature also?

I think I wasn't supposed to force-push the branch to physically move it to the features branch, but now I know about that GitHub feature..

@kalekundert

This comment has been minimized.

Copy link
Contributor

kalekundert commented Nov 19, 2018

It might be worth adding a test to make sure __repr__() works after making a comparison with a generator (i.e. because the generator would be consumed during the iteration, approx needs to make a copy in order to present a nice error message if the comparison fails). This might just work—I don't remember how the code is written—but it seems worth testing.

@nicoddemus

This comment has been minimized.

Copy link
Member

nicoddemus commented Nov 19, 2018

Changed to be on top of the feature branch (though should I change the news classification to a feature also?

Yes please. 👍

It might be worth adding a test to make sure repr() works after making a comparison with a generator

Oh good catch! It is definitely worth having a test for this. 👍

@nicoddemus

This comment has been minimized.

Copy link
Member

nicoddemus commented Dec 14, 2018

@RonnyPfannschmidt anything else here or can we merge this?

@RonnyPfannschmidt RonnyPfannschmidt merged commit e63c7a1 into pytest-dev:features Dec 17, 2018

4 checks passed

codecov/patch 100% of diff hit (target 95.88%)
Details
codecov/project 95.93% (+0.05%) compared to 62967b3
Details
continuous-integration/appveyor/pr AppVeyor build succeeded
Details
continuous-integration/travis-ci/pr The Travis CI build passed
Details

bors bot added a commit to mozilla/normandy that referenced this pull request Jan 8, 2019

Merge #1680
1680: Scheduled weekly dependency update for week 01 r=mythmon a=pyup-bot






### Update [botocore](https://pypi.org/project/botocore) from **1.12.62** to **1.12.74**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.12.74
   ```
   =======

* api-change:``ecs``: Update ecs client to latest version
* api-change:``devicefarm``: Update devicefarm client to latest version
   ```
   
  
  
   ### 1.12.73
   ```
   =======

* api-change:``iotanalytics``: Update iotanalytics client to latest version
   ```
   
  
  
   ### 1.12.72
   ```
   =======

* enhancement:Paginator: Added over 400 new paginators.
* api-change:``opsworkscm``: Update opsworkscm client to latest version
   ```
   
  
  
   ### 1.12.71
   ```
   =======

* api-change:``acm-pca``: Update acm-pca client to latest version
* api-change:``dynamodb``: Update dynamodb client to latest version
* api-change:``sms-voice``: Update sms-voice client to latest version
* api-change:``stepfunctions``: Update stepfunctions client to latest version
   ```
   
  
  
   ### 1.12.70
   ```
   =======

* api-change:``medialive``: Update medialive client to latest version
* enhancement:EndpointDiscovery: Add a config option, ``endpoint_discovery_enabled``, for automatically discovering endpoints
* api-change:``comprehend``: Update comprehend client to latest version
* api-change:``firehose``: Update firehose client to latest version
* api-change:``transcribe``: Update transcribe client to latest version
* api-change:``cognito-idp``: Update cognito-idp client to latest version
   ```
   
  
  
   ### 1.12.69
   ```
   =======

* api-change:``sagemaker``: Update sagemaker client to latest version
* api-change:``waf-regional``: Update waf-regional client to latest version
* api-change:``ec2``: Update ec2 client to latest version
* api-change:``waf``: Update waf client to latest version
   ```
   
  
  
   ### 1.12.68
   ```
   =======

* api-change:``apigatewayv2``: Update apigatewayv2 client to latest version
* bugfix:Credentials: Fixes an issue where credentials would be checked when creating an anonymous client. Fixes `1472 &lt;https://github.com/boto/botocore/issues/1472&gt;`__
* api-change:``ec2``: Update ec2 client to latest version
* api-change:``elasticbeanstalk``: Update elasticbeanstalk client to latest version
* api-change:``globalaccelerator``: Update globalaccelerator client to latest version
* enhancement:StreamingBody: Support iterating lines from a streaming response body with CRLF line endings
* api-change:``apigatewaymanagementapi``: Update apigatewaymanagementapi client to latest version
   ```
   
  
  
   ### 1.12.67
   ```
   =======

* api-change:``quicksight``: Update quicksight client to latest version
* api-change:``ecr``: Update ecr client to latest version
   ```
   
  
  
   ### 1.12.66
   ```
   =======

* api-change:``alexaforbusiness``: Update alexaforbusiness client to latest version
* api-change:``redshift``: Update redshift client to latest version
* api-change:``cloudformation``: Update cloudformation client to latest version
   ```
   
  
  
   ### 1.12.65
   ```
   =======

* api-change:``organizations``: Update organizations client to latest version
* api-change:``pinpoint-email``: Update pinpoint-email client to latest version
   ```
   
  
  
   ### 1.12.64
   ```
   =======

* api-change:``route53``: Update route53 client to latest version
* api-change:``glue``: Update glue client to latest version
* api-change:``sagemaker``: Update sagemaker client to latest version
* api-change:``eks``: Update eks client to latest version
   ```
   
  
  
   ### 1.12.63
   ```
   =======

* api-change:``mediastore``: Update mediastore client to latest version
* api-change:``ecs``: Update ecs client to latest version
* api-change:``connect``: Update connect client to latest version
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/botocore
  - Changelog: https://pyup.io/changelogs/botocore/
  - Repo: https://github.com/boto/botocore
</details>





### Update [Faker](https://pypi.org/project/Faker) from **1.0.0** to **1.0.1**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.0.1
   ```
   * 1 minor enhancement
    * Added safe_email method to get someaddressexample.com [Kazimierz Kiełkowicz]
* 1 bug fix:
    * Use the locale fallback properly when parsing string formats
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/faker
  - Changelog: https://pyup.io/changelogs/faker/
  - Repo: https://github.com/joke2k/faker
</details>





### Update [more-itertools](https://pypi.org/project/more-itertools) from **4.3.0** to **5.0.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 5.0.0
   ```
   See PR 252 for notes.
   ```
   
  
  
   ### 4.3.1
   ```
   This is [version 4.3.0](https://github.com/erikrose/more-itertools/releases/tag/4.3.0) plus PR 226 . There is no corresponding PyPI release; this is just to fix the docs on RTD.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/more-itertools
  - Changelog: https://pyup.io/changelogs/more-itertools/
  - Repo: https://github.com/erikrose/more-itertools
  - Docs: https://pythonhosted.org/more-itertools/
</details>





### Update [pytz](https://pypi.org/project/pytz) from **2018.7** to **2018.9**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pytz
  - Homepage: http://pythonhosted.org/pytz
  - Docs: https://pythonhosted.org/pytz/
</details>





### Update [setuptools](https://pypi.org/project/setuptools) from **40.6.2** to **40.6.3**.


<details>
  <summary>Changelog</summary>
  
  
   ### 40.6.3
   ```
   -------

* 1594: PEP 517 backend no longer declares setuptools as a dependency as it can be assumed.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/setuptools
  - Changelog: https://pyup.io/changelogs/setuptools/
  - Repo: https://github.com/pypa/setuptools
</details>





### Update [Pygments](https://pypi.org/project/Pygments) from **2.3.0** to **2.3.1**.


<details>
  <summary>Changelog</summary>
  
  
   ### 2.3.1
   ```
   -------------
(released Dec 16, 2018)

- Updated lexers:

  * ASM (PR784)
  * Chapel (PR735)
  * Clean (PR621)
  * CSound (PR684)
  * Elm (PR744)
  * Fortran (PR747)
  * GLSL (PR740)
  * Haskell (PR745)
  * Hy (PR754)
  * Igor Pro (PR764)
  * PowerShell (PR705)
  * Python (PR720, 1299, PR715)
  * SLexer (PR680)
  * YAML (PR762, PR724)

- Fix invalid string escape sequences
- Fix `FutureWarning` introduced by regex changes in Python 3.7
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pygments
  - Changelog: https://pyup.io/changelogs/pygments/
  - Homepage: http://pygments.org/
</details>





### Update [google-api-core](https://pypi.org/project/google-api-core) from **1.6.0** to **1.7.0**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-api-core
  - Repo: https://github.com/GoogleCloudPlatform/google-cloud-python
</details>





### Update [google-resumable-media](https://pypi.org/project/google-resumable-media) from **0.3.1** to **0.3.2**.


<details>
  <summary>Changelog</summary>
  
  
   ### 0.3.2
   ```
   12-17-2018 17:31 PST

 Implementation Changes
- Using `str` instead of `repr` for multipart boundary.

 Dependencies
- Making `requests` a strict dependency for the `requests` subpackage.

 Documentation
- Announce deprecation of Python 2.7 ([51](googleapis/google-resumable-media-python#51))
- Fix broken redirect after repository move
- Updating generated static content in docs.

 Internal / Testing Changes
- Modify file not found test to look for the correct error message
- Harden tests so they can run with debug logging statements
- Adding AppVeyor support.
- Marking the version in `master` as `.dev1`.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-resumable-media
  - Changelog: https://pyup.io/changelogs/google-resumable-media/
  - Repo: https://github.com/GoogleCloudPlatform/google-resumable-media-python
</details>





### Update [google-auth](https://pypi.org/project/google-auth) from **1.6.1** to **1.6.2**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.6.2
   ```
   ------

12-17-2018 10:51 PST

Documentation
+++++++++++++

- Announce deprecation of Python 2.7 (`311 &lt;https://github.com/googleapis/google-auth-library-python/pull/311&gt;`_)
- Link all the PRs in CHANGELOG (`307 &lt;https://github.com/googleapis/google-auth-library-python/pull/307&gt;`_)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-auth
  - Changelog: https://pyup.io/changelogs/google-auth/
  - Repo: https://github.com/GoogleCloudPlatform/google-auth-library-python
</details>





### Update [Unidecode](https://pypi.org/project/Unidecode) from **1.0.22** to **1.0.23**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.0.23
   ```
   * Improve transliteration of Hebrew letters (thanks to Alon Bar-Lev)
	* Add transliterations for the phonetic block U+1D00 - U+1D7F
	  (thanks to Oscar Laurent)
	* Transliterate SI &quot;micro&quot; prefix as &quot;u&quot; instead of &quot;micro&quot; in the
	  U+33xx block.
	* Add U+33DE SQUARE V OVER M and U+33DF SQUARE A OVER M.
	* Drop support for Python 2.6 and 3.3 (thanks to Jon Dufresne)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/unidecode
  - Changelog: https://pyup.io/changelogs/unidecode/
</details>





### Update [bcrypt](https://pypi.org/project/bcrypt) from **3.1.4** to **3.1.5**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/bcrypt
  - Repo: https://github.com/pyca/bcrypt/
</details>





### Update [boto3](https://pypi.org/project/boto3) from **1.9.62** to **1.9.74**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.9.74
   ```
   ======

* api-change:``ecs``: [``botocore``] Update ecs client to latest version
* api-change:``devicefarm``: [``botocore``] Update devicefarm client to latest version
   ```
   
  
  
   ### 1.9.73
   ```
   ======

* api-change:``iotanalytics``: [``botocore``] Update iotanalytics client to latest version
   ```
   
  
  
   ### 1.9.72
   ```
   ======

* enhancement:Paginator: [``botocore``] Added over 400 new paginators.
* api-change:``opsworkscm``: [``botocore``] Update opsworkscm client to latest version
   ```
   
  
  
   ### 1.9.71
   ```
   ======

* api-change:``acm-pca``: [``botocore``] Update acm-pca client to latest version
* api-change:``dynamodb``: [``botocore``] Update dynamodb client to latest version
* api-change:``sms-voice``: [``botocore``] Update sms-voice client to latest version
* api-change:``stepfunctions``: [``botocore``] Update stepfunctions client to latest version
   ```
   
  
  
   ### 1.9.70
   ```
   ======

* api-change:``medialive``: [``botocore``] Update medialive client to latest version
* enhancement:EndpointDiscovery: [``botocore``] Add a config option, ``endpoint_discovery_enabled``, for automatically discovering endpoints
* api-change:``comprehend``: [``botocore``] Update comprehend client to latest version
* api-change:``firehose``: [``botocore``] Update firehose client to latest version
* api-change:``transcribe``: [``botocore``] Update transcribe client to latest version
* api-change:``cognito-idp``: [``botocore``] Update cognito-idp client to latest version
   ```
   
  
  
   ### 1.9.69
   ```
   ======

* api-change:``sagemaker``: [``botocore``] Update sagemaker client to latest version
* api-change:``waf-regional``: [``botocore``] Update waf-regional client to latest version
* api-change:``ec2``: [``botocore``] Update ec2 client to latest version
* api-change:``waf``: [``botocore``] Update waf client to latest version
   ```
   
  
  
   ### 1.9.68
   ```
   ======

* api-change:``apigatewayv2``: [``botocore``] Update apigatewayv2 client to latest version
* bugfix:Credentials: [``botocore``] Fixes an issue where credentials would be checked when creating an anonymous client. Fixes `1472 &lt;https://github.com/boto/botocore/issues/1472&gt;`__
* api-change:``ec2``: [``botocore``] Update ec2 client to latest version
* api-change:``elasticbeanstalk``: [``botocore``] Update elasticbeanstalk client to latest version
* api-change:``globalaccelerator``: [``botocore``] Update globalaccelerator client to latest version
* enhancement:StreamingBody: [``botocore``] Support iterating lines from a streaming response body with CRLF line endings
* api-change:``apigatewaymanagementapi``: [``botocore``] Update apigatewaymanagementapi client to latest version
   ```
   
  
  
   ### 1.9.67
   ```
   ======

* api-change:``quicksight``: [``botocore``] Update quicksight client to latest version
* api-change:``ecr``: [``botocore``] Update ecr client to latest version
   ```
   
  
  
   ### 1.9.66
   ```
   ======

* api-change:``alexaforbusiness``: [``botocore``] Update alexaforbusiness client to latest version
* api-change:``redshift``: [``botocore``] Update redshift client to latest version
* api-change:``cloudformation``: [``botocore``] Update cloudformation client to latest version
   ```
   
  
  
   ### 1.9.65
   ```
   ======

* api-change:``organizations``: [``botocore``] Update organizations client to latest version
* api-change:``pinpoint-email``: [``botocore``] Update pinpoint-email client to latest version
   ```
   
  
  
   ### 1.9.64
   ```
   ======

* api-change:``route53``: [``botocore``] Update route53 client to latest version
* api-change:``glue``: [``botocore``] Update glue client to latest version
* api-change:``sagemaker``: [``botocore``] Update sagemaker client to latest version
* api-change:``eks``: [``botocore``] Update eks client to latest version
   ```
   
  
  
   ### 1.9.63
   ```
   ======

* api-change:``mediastore``: [``botocore``] Update mediastore client to latest version
* api-change:``ecs``: [``botocore``] Update ecs client to latest version
* api-change:``connect``: [``botocore``] Update connect client to latest version
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/boto3
  - Changelog: https://pyup.io/changelogs/boto3/
  - Repo: https://github.com/boto/boto3
</details>





### Update [Django](https://pypi.org/project/Django) from **2.0.9** to **2.0.10**.


<details>
  <summary>Changelog</summary>
  
  
   ### 2.0.10
   ```
   ===========================

*January 4, 2019*

Django 2.0.10 fixes a security issue and several bugs in 2.0.9.

CVE-2019-3498: Content spoofing possibility in the default 404 page
-------------------------------------------------------------------

An attacker could craft a malicious URL that could make spoofed content appear
on the default page generated by the ``django.views.defaults.page_not_found()``
view.

The URL path is no longer displayed in the default 404 template and the
``request_path`` context variable is now quoted to fix the issue for custom
templates that use the path.

Bugfixes
========

* Prevented repetitive calls to ``geos_version_tuple()`` in the ``WKBWriter``
  class in an attempt to fix a random crash involving ``LooseVersion`` since
  Django 2.0.6 (🎫`29959`).

* Fixed a schema corruption issue on SQLite 3.26+. You might have to drop and
  rebuild your SQLite database if you applied a migration while using an older
  version of Django with SQLite 3.26 or later (🎫`29182`).

* Prevented SQLite schema alterations while foreign key checks are enabled to
  avoid the possibility of schema corruption (🎫`30023`).


==========================
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/django
  - Changelog: https://pyup.io/changelogs/django/
  - Homepage: https://www.djangoproject.com/
</details>





### Update [gevent](https://pypi.org/project/gevent) from **1.3.7** to **1.4.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.4.0
   ```
   ==================

- Build with Cython 0.29 in &#39;3str&#39; mode.

- Test with PyPy 6.0 on Windows.

- Add support for application-wide callbacks when ``Greenlet`` objects
  are started. See :pr:`1289`, provided by Yury Selivanov.

- Fix consuming a single ready object using
  ``next(gevent.iwait(objs))``. Previously such a construction would
  hang because `iter` was not called. See :pr:`1288`, provided by Josh
  Snyder. This is not recommended, though, as unwaited objects will
  have dangling links (but see next item).

- Make `gevent.iwait` return an iterator that can now also be used as
  a context manager. If you&#39;ll only be consuming part of the iterator,
  use it in a ``with`` block to avoid leaking resources. See
  :pr:`1290`, provided by Josh Snyder.

- Fix semaphores to immediately notify links if they are ready and
  ``rawlink()`` is called. This behaves like ``Event`` and
  ``AsyncEvent``. Note that the order in which semaphore links are
  called is not specified. See :issue:`1287`, reported by Dan Milon.

- Improve safety of handling exceptions during interpreter shutdown.
  See :issue:`1295` reported by BobDenar1212.

- Remove the deprecated ability to specify ``GEVENT_RESOLVER`` and
  other importable settings as a ``path/to/a/package.module.item``.
  This had race conditions and didn&#39;t work with complicated resolver
  implementations. Place the required package or module on `sys.path`
  first.

- Reduce the chances that using the blocking monitor functionality
  could result in apparently random ``SystemError:
  Objects/tupleobject.c: bad argument to internal function``. Reported
  in :issue:`1302` by Ulrich Petri.

- Refactored the gevent test runner and test suite to make them more
  reusable. In particular, the tests are now run with ``python -m
  gevent.tests``. See :issue:`1293`.

- Make a monkey-patched ``socket.getaddrinfo`` return socket module
  enums instead of plain integers for the socket type and address
  family on Python 3. See :issue:`1310` reported by TheYOSH.

- Make gevent&#39;s pywsgi server set the non-standard environment value
  ``wsgi.input_terminated`` to True. See :issue:`1308`.

- Make `gevent.util.assert_switches` produce more informative messages
  when the assertion fails.

- Python 2: If a `gevent.socket` was closed asynchronously (in a
  different greenlet or a hub callback), `AttributeError` could result
  if the socket was already in use. Now the correct socket.error
  should be raised.

- Fix :meth:`gevent.threadpool.ThreadPool.join` raising a
  `UserWarning` when using the libuv backend. Reported in
  :issue:`1321` by ZeroNet.

- Fix ``FileObjectPosix.seek`` raising `OSError` when it should have
  been `IOError` on Python 2. Reported by, and PR by, Ricardo Kirkner.
  See :issue:`1323`.

- Upgrade libuv from 1.23.2 to 1.24.0.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/gevent
  - Changelog: https://pyup.io/changelogs/gevent/
  - Homepage: http://www.gevent.org/
</details>





### Update [pyasn1](https://pypi.org/project/pyasn1) from **0.4.4** to **0.4.5**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pyasn1
  - Changelog: https://pyup.io/changelogs/pyasn1/
  - Repo: https://github.com/etingof/pyasn1
</details>





### Update [pyasn1-modules](https://pypi.org/project/pyasn1-modules) from **0.2.2** to **0.2.3**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pyasn1-modules
  - Changelog: https://pyup.io/changelogs/pyasn1-modules/
  - Repo: https://github.com/etingof/pyasn1-modules
</details>





### Update [pytest](https://pypi.org/project/pytest) from **4.0.1** to **4.1.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 4.1.0
   ```
   =========================

Removals
--------

- `2169 &lt;https://github.com/pytest-dev/pytest/issues/2169&gt;`_: ``pytest.mark.parametrize``: in previous versions, errors raised by id functions were suppressed and changed into warnings. Now the exceptions are propagated, along with a pytest message informing the node, parameter value and index where the exception occurred.


- `3078 &lt;https://github.com/pytest-dev/pytest/issues/3078&gt;`_: Remove legacy internal warnings system: ``config.warn``, ``Node.warn``. The ``pytest_logwarning`` now issues a warning when implemented.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlconfig-warn-and-node-warn&gt;`__ on information on how to update your code.


- `3079 &lt;https://github.com/pytest-dev/pytest/issues/3079&gt;`_: Removed support for yield tests - they are fundamentally broken because they don&#39;t support fixtures properly since collection and test execution were separated.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlyield-tests&gt;`__ on information on how to update your code.


- `3082 &lt;https://github.com/pytest-dev/pytest/issues/3082&gt;`_: Removed support for applying marks directly to values in ``pytest.mark.parametrize``. Use ``pytest.param`` instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlmarks-in-pytest-mark-parametrize&gt;`__ on information on how to update your code.


- `3083 &lt;https://github.com/pytest-dev/pytest/issues/3083&gt;`_: Removed ``Metafunc.addcall``. This was the predecessor mechanism to ``pytest.mark.parametrize``.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlmetafunc-addcall&gt;`__ on information on how to update your code.


- `3085 &lt;https://github.com/pytest-dev/pytest/issues/3085&gt;`_: Removed support for passing strings to ``pytest.main``. Now, always pass a list of strings instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpassing-command-line-string-to-pytest-main&gt;`__ on information on how to update your code.


- `3086 &lt;https://github.com/pytest-dev/pytest/issues/3086&gt;`_: ``[pytest]`` section in **setup.cfg** files is not longer supported, use ``[tool:pytest]`` instead. ``setup.cfg`` files
  are meant for use with ``distutils``, and a section named ``pytest`` has notoriously been a source of conflicts and bugs.

  Note that for **pytest.ini** and **tox.ini** files the section remains ``[pytest]``.


- `3616 &lt;https://github.com/pytest-dev/pytest/issues/3616&gt;`_: Removed the deprecated compat properties for ``node.Class/Function/Module`` - use ``pytest.Class/Function/Module`` now.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlinternal-classes-accessed-through-node&gt;`__ on information on how to update your code.


- `4421 &lt;https://github.com/pytest-dev/pytest/issues/4421&gt;`_: Removed the implementation of the ``pytest_namespace`` hook.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-namespace&gt;`__ on information on how to update your code.


- `4489 &lt;https://github.com/pytest-dev/pytest/issues/4489&gt;`_: Removed ``request.cached_setup``. This was the predecessor mechanism to modern fixtures.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlcached-setup&gt;`__ on information on how to update your code.


- `4535 &lt;https://github.com/pytest-dev/pytest/issues/4535&gt;`_: Removed the deprecated ``PyCollector.makeitem`` method. This method was made public by mistake a long time ago.


- `4543 &lt;https://github.com/pytest-dev/pytest/issues/4543&gt;`_: Removed support to define fixtures using the ``pytest_funcarg__`` prefix. Use the ``pytest.fixture`` decorator instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-funcarg-prefix&gt;`__ on information on how to update your code.


- `4545 &lt;https://github.com/pytest-dev/pytest/issues/4545&gt;`_: Calling fixtures directly is now always an error instead of a warning.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlcalling-fixtures-directly&gt;`__ on information on how to update your code.


- `4546 &lt;https://github.com/pytest-dev/pytest/issues/4546&gt;`_: Remove ``Node.get_marker(name)`` the return value was not usable for more than a existence check.

  Use ``Node.get_closest_marker(name)`` as a replacement.


- `4547 &lt;https://github.com/pytest-dev/pytest/issues/4547&gt;`_: The deprecated ``record_xml_property`` fixture has been removed, use the more generic ``record_property`` instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlrecord-xml-property&gt;`__ for more information.


- `4548 &lt;https://github.com/pytest-dev/pytest/issues/4548&gt;`_: An error is now raised if the ``pytest_plugins`` variable is defined in a non-top-level ``conftest.py`` file (i.e., not residing in the ``rootdir``).

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-plugins-in-non-top-level-conftest-files&gt;`__ for more information.


- `891 &lt;https://github.com/pytest-dev/pytest/issues/891&gt;`_: Remove ``testfunction.markername`` attributes - use ``Node.iter_markers(name=None)`` to iterate them.



Deprecations
------------

- `3050 &lt;https://github.com/pytest-dev/pytest/issues/3050&gt;`_: Deprecated the ``pytest.config`` global.

  See https://docs.pytest.org/en/latest/deprecations.htmlpytest-config-global for rationale.


- `3974 &lt;https://github.com/pytest-dev/pytest/issues/3974&gt;`_: Passing the ``message`` parameter of ``pytest.raises`` now issues a ``DeprecationWarning``.

  It is a common mistake to think this parameter will match the exception message, while in fact
  it only serves to provide a custom message in case the ``pytest.raises`` check fails. To avoid this
  mistake and because it is believed to be little used, pytest is deprecating it without providing
  an alternative for the moment.

  If you have concerns about this, please comment on `issue 3974 &lt;https://github.com/pytest-dev/pytest/issues/3974&gt;`__.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Deprecated ``raises(..., &#39;code(as_a_string)&#39;)`` and ``warns(..., &#39;code(as_a_string)&#39;)``.

  See https://docs.pytest.org/en/latest/deprecations.htmlraises-warns-exec for rationale and examples.



Features
--------

- `3191 &lt;https://github.com/pytest-dev/pytest/issues/3191&gt;`_: A warning is now issued when assertions are made for ``None``.

  This is a common source of confusion among new users, which write:

  .. code-block:: python

      assert mocked_object.assert_called_with(3, 4, 5, key=&quot;value&quot;)

  When they should write:

  .. code-block:: python

      mocked_object.assert_called_with(3, 4, 5, key=&quot;value&quot;)

  Because the ``assert_called_with`` method of mock objects already executes an assertion.

  This warning will not be issued when ``None`` is explicitly checked. An assertion like:

  .. code-block:: python

      assert variable is None

  will not issue the warning.


- `3632 &lt;https://github.com/pytest-dev/pytest/issues/3632&gt;`_: Richer equality comparison introspection on ``AssertionError`` for objects created using `attrs &lt;http://www.attrs.org/en/stable/&gt;`__ or `dataclasses &lt;https://docs.python.org/3/library/dataclasses.html&gt;`_ (Python 3.7+, `backported to 3.6 &lt;https://pypi.org/project/dataclasses&gt;`__).


- `4278 &lt;https://github.com/pytest-dev/pytest/issues/4278&gt;`_: ``CACHEDIR.TAG`` files are now created inside cache directories.

  Those files are part of the `Cache Directory Tagging Standard &lt;http://www.bford.info/cachedir/spec.html&gt;`__, and can
  be used by backup or synchronization programs to identify pytest&#39;s cache directory as such.


- `4292 &lt;https://github.com/pytest-dev/pytest/issues/4292&gt;`_: ``pytest.outcomes.Exit`` is derived from ``SystemExit`` instead of ``KeyboardInterrupt``. This allows us to better handle ``pdb`` exiting.


- `4371 &lt;https://github.com/pytest-dev/pytest/issues/4371&gt;`_: Updated the ``--collect-only`` option to display test descriptions when ran using ``--verbose``.


- `4386 &lt;https://github.com/pytest-dev/pytest/issues/4386&gt;`_: Restructured ``ExceptionInfo`` object construction and ensure incomplete instances have a ``repr``/``str``.


- `4416 &lt;https://github.com/pytest-dev/pytest/issues/4416&gt;`_: pdb: added support for keyword arguments with ``pdb.set_trace``.

  It handles ``header`` similar to Python 3.7 does it, and forwards any
  other keyword arguments to the ``Pdb`` constructor.

  This allows for ``__import__(&quot;pdb&quot;).set_trace(skip=[&quot;foo.*&quot;])``.


- `4483 &lt;https://github.com/pytest-dev/pytest/issues/4483&gt;`_: Added ini parameter ``junit_duration_report`` to optionally report test call durations, excluding setup and teardown times.

  The JUnit XML specification and the default pytest behavior is to include setup and teardown times in the test duration
  report. You can include just the call durations instead (excluding setup and teardown) by adding this to your ``pytest.ini`` file:

  .. code-block:: ini

      [pytest]
      junit_duration_report = call


- `4532 &lt;https://github.com/pytest-dev/pytest/issues/4532&gt;`_: ``-ra`` now will show errors and failures last, instead of as the first items in the summary.

  This makes it easier to obtain a list of errors and failures to run tests selectively.


- `4599 &lt;https://github.com/pytest-dev/pytest/issues/4599&gt;`_: ``pytest.importorskip`` now supports a ``reason`` parameter, which will be shown when the
  requested module cannot be imported.



Bug Fixes
---------

- `3532 &lt;https://github.com/pytest-dev/pytest/issues/3532&gt;`_: ``-p`` now accepts its argument without a space between the value, for example ``-pmyplugin``.


- `4327 &lt;https://github.com/pytest-dev/pytest/issues/4327&gt;`_: ``approx`` again works with more generic containers, more precisely instances of ``Iterable`` and ``Sized`` instead of more restrictive ``Sequence``.


- `4397 &lt;https://github.com/pytest-dev/pytest/issues/4397&gt;`_: Ensure that node ids are printable.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Fixed ``raises(..., &#39;code(string)&#39;)`` frame filename.


- `4458 &lt;https://github.com/pytest-dev/pytest/issues/4458&gt;`_: Display actual test ids in ``--collect-only``.



Improved Documentation
----------------------

- `4557 &lt;https://github.com/pytest-dev/pytest/issues/4557&gt;`_: Markers example documentation page updated to support latest pytest version.


- `4558 &lt;https://github.com/pytest-dev/pytest/issues/4558&gt;`_: Update cache documentation example to correctly show cache hit and miss.


- `4580 &lt;https://github.com/pytest-dev/pytest/issues/4580&gt;`_: Improved detailed summary report documentation.



Trivial/Internal Changes
------------------------

- `4447 &lt;https://github.com/pytest-dev/pytest/issues/4447&gt;`_: Changed the deprecation type of ``--result-log`` to ``PytestDeprecationWarning``.

  It was decided to remove this feature at the next major revision.
   ```
   
  
  
   ### 4.0.2
   ```
   =========================

Bug Fixes
---------

- `4265 &lt;https://github.com/pytest-dev/pytest/issues/4265&gt;`_: Validate arguments from the ``PYTEST_ADDOPTS`` environment variable and the ``addopts`` ini option separately.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Fix ``raises(..., &#39;code(string)&#39;)`` frame filename.


- `4500 &lt;https://github.com/pytest-dev/pytest/issues/4500&gt;`_: When a fixture yields and a log call is made after the test runs, and, if the test is interrupted, capture attributes are ``None``.


- `4538 &lt;https://github.com/pytest-dev/pytest/issues/4538&gt;`_: Raise ``TypeError`` for ``with raises(..., match=&lt;non-None falsey value&gt;)``.



Improved Documentation
----------------------

- `1495 &lt;https://github.com/pytest-dev/pytest/issues/1495&gt;`_: Document common doctest fixture directory tree structure pitfalls
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pytest
  - Changelog: https://pyup.io/changelogs/pytest/
  - Homepage: https://docs.pytest.org/en/latest/
</details>





### Update [raven](https://pypi.org/project/raven) from **6.9.0** to **6.10.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 6.10.0
   ```
   ------

* [Core] Fixed stackframes in some situations being in inverse order.
* [Flask] Fix wrong exception handling logic (accidentally relied on Flask internals).
* [Core] No longer send NaN local vars as non-standard JSON.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/raven
  - Changelog: https://pyup.io/changelogs/raven/
  - Repo: https://github.com/getsentry/raven-python
</details>





### Update [backoff](https://pypi.org/project/backoff) from **1.7.1** to **1.8.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.8.0
   ```
   Changed

- Give up on StopIteration raised in wait generators
- Iterable intervals for constant wait_gen for predefined wait sequences
- Nullary jitter signature deprecation warning
- Custom loggers
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/backoff
  - Changelog: https://pyup.io/changelogs/backoff/
  - Repo: https://github.com/litl/backoff
</details>





### Update [google-cloud-storage](https://pypi.org/project/google-cloud-storage) from **1.13.0** to **1.13.2**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-cloud-storage
  - Repo: https://github.com/GoogleCloudPlatform/google-cloud-python
</details>





### Update [kinto-http](https://pypi.org/project/kinto-http) from **10.1.0** to **10.2.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 10.2.0
   ```
   ===================

**New features**

- Created new method on client to get paginated records ``get_paginated_records``. (175)
- Allow additional querystring params in `get_*()` methods
   ```
   
  
  
   ### 10.1.1
   ```
   ===================

**Bug fixes**

- Fix JSON support for `in_` and `exclude_`. (188)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/kinto-http
  - Changelog: https://pyup.io/changelogs/kinto-http/
  - Repo: https://github.com/Kinto/kinto-http.py/
</details>





### Update [Sphinx](https://pypi.org/project/Sphinx) from **1.8.2** to **1.8.3**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.8.3
   ```
   ==============================

Dependencies
------------

Incompatible changes
--------------------

Deprecated
----------

Features added
--------------

* LaTeX: it is possible to insert custom material to appear on back of title
  page, see discussion of ``&#39;maketitle&#39;`` key of :confval:`latex_elements`
  (``&#39;manual&#39;`` docclass only)

Bugs fixed
----------

* 5725: mathjax: Use CDN URL for &quot;latest&quot; version by default
* 5460: html search does not work with some 3rd party themes
* 5520: LaTeX, caption package incompatibility since Sphinx 1.6
* 5614: autodoc: incremental build is broken when builtin modules are imported
* 5627: qthelp: index.html missing in QtHelp
* 5659: linkcheck: crashes for a hyperlink containing multibyte character
* 5754: DOC: Fix some mistakes in :doc:`/latex`
* 5810: LaTeX: sphinxVerbatim requires explicit &quot;hllines&quot; set-up since 1.6.6
  (refs: 1238)
* 5636: C++, fix parsing of floating point literals.
* 5496 (again): C++, fix assertion in partial builds with duplicates.
* 5724: quickstart: sphinx-quickstart fails when $LC_ALL is empty
* 1956: Default conf.py is not PEP8-compliant
* 5849: LaTeX: document class ``\maketitle`` is overwritten with no
  possibility to use original meaning in place of Sphinx custom one
* 5834: apidoc: wrong help for ``--tocfile``
* 5800: todo: crashed if todo is defined in TextElement
* 5846: htmlhelp: convert hex escaping to decimal escaping in .hhc/.hhk files

Testing
--------
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/sphinx
  - Changelog: https://pyup.io/changelogs/sphinx/
  - Homepage: http://sphinx-doc.org/
</details>







Co-authored-by: pyup-bot <github-bot@pyup.io>
Co-authored-by: Peter Bengtsson <mail@peterbe.com>

bors bot added a commit to mozilla/normandy that referenced this pull request Jan 8, 2019

Merge #1680
1680: Scheduled weekly dependency update for week 01 r=mythmon a=pyup-bot






### Update [botocore](https://pypi.org/project/botocore) from **1.12.62** to **1.12.74**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.12.74
   ```
   =======

* api-change:``ecs``: Update ecs client to latest version
* api-change:``devicefarm``: Update devicefarm client to latest version
   ```
   
  
  
   ### 1.12.73
   ```
   =======

* api-change:``iotanalytics``: Update iotanalytics client to latest version
   ```
   
  
  
   ### 1.12.72
   ```
   =======

* enhancement:Paginator: Added over 400 new paginators.
* api-change:``opsworkscm``: Update opsworkscm client to latest version
   ```
   
  
  
   ### 1.12.71
   ```
   =======

* api-change:``acm-pca``: Update acm-pca client to latest version
* api-change:``dynamodb``: Update dynamodb client to latest version
* api-change:``sms-voice``: Update sms-voice client to latest version
* api-change:``stepfunctions``: Update stepfunctions client to latest version
   ```
   
  
  
   ### 1.12.70
   ```
   =======

* api-change:``medialive``: Update medialive client to latest version
* enhancement:EndpointDiscovery: Add a config option, ``endpoint_discovery_enabled``, for automatically discovering endpoints
* api-change:``comprehend``: Update comprehend client to latest version
* api-change:``firehose``: Update firehose client to latest version
* api-change:``transcribe``: Update transcribe client to latest version
* api-change:``cognito-idp``: Update cognito-idp client to latest version
   ```
   
  
  
   ### 1.12.69
   ```
   =======

* api-change:``sagemaker``: Update sagemaker client to latest version
* api-change:``waf-regional``: Update waf-regional client to latest version
* api-change:``ec2``: Update ec2 client to latest version
* api-change:``waf``: Update waf client to latest version
   ```
   
  
  
   ### 1.12.68
   ```
   =======

* api-change:``apigatewayv2``: Update apigatewayv2 client to latest version
* bugfix:Credentials: Fixes an issue where credentials would be checked when creating an anonymous client. Fixes `1472 &lt;https://github.com/boto/botocore/issues/1472&gt;`__
* api-change:``ec2``: Update ec2 client to latest version
* api-change:``elasticbeanstalk``: Update elasticbeanstalk client to latest version
* api-change:``globalaccelerator``: Update globalaccelerator client to latest version
* enhancement:StreamingBody: Support iterating lines from a streaming response body with CRLF line endings
* api-change:``apigatewaymanagementapi``: Update apigatewaymanagementapi client to latest version
   ```
   
  
  
   ### 1.12.67
   ```
   =======

* api-change:``quicksight``: Update quicksight client to latest version
* api-change:``ecr``: Update ecr client to latest version
   ```
   
  
  
   ### 1.12.66
   ```
   =======

* api-change:``alexaforbusiness``: Update alexaforbusiness client to latest version
* api-change:``redshift``: Update redshift client to latest version
* api-change:``cloudformation``: Update cloudformation client to latest version
   ```
   
  
  
   ### 1.12.65
   ```
   =======

* api-change:``organizations``: Update organizations client to latest version
* api-change:``pinpoint-email``: Update pinpoint-email client to latest version
   ```
   
  
  
   ### 1.12.64
   ```
   =======

* api-change:``route53``: Update route53 client to latest version
* api-change:``glue``: Update glue client to latest version
* api-change:``sagemaker``: Update sagemaker client to latest version
* api-change:``eks``: Update eks client to latest version
   ```
   
  
  
   ### 1.12.63
   ```
   =======

* api-change:``mediastore``: Update mediastore client to latest version
* api-change:``ecs``: Update ecs client to latest version
* api-change:``connect``: Update connect client to latest version
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/botocore
  - Changelog: https://pyup.io/changelogs/botocore/
  - Repo: https://github.com/boto/botocore
</details>





### Update [Faker](https://pypi.org/project/Faker) from **1.0.0** to **1.0.1**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.0.1
   ```
   * 1 minor enhancement
    * Added safe_email method to get someaddressexample.com [Kazimierz Kiełkowicz]
* 1 bug fix:
    * Use the locale fallback properly when parsing string formats
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/faker
  - Changelog: https://pyup.io/changelogs/faker/
  - Repo: https://github.com/joke2k/faker
</details>





### Update [more-itertools](https://pypi.org/project/more-itertools) from **4.3.0** to **5.0.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 5.0.0
   ```
   See PR 252 for notes.
   ```
   
  
  
   ### 4.3.1
   ```
   This is [version 4.3.0](https://github.com/erikrose/more-itertools/releases/tag/4.3.0) plus PR 226 . There is no corresponding PyPI release; this is just to fix the docs on RTD.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/more-itertools
  - Changelog: https://pyup.io/changelogs/more-itertools/
  - Repo: https://github.com/erikrose/more-itertools
  - Docs: https://pythonhosted.org/more-itertools/
</details>





### Update [pytz](https://pypi.org/project/pytz) from **2018.7** to **2018.9**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pytz
  - Homepage: http://pythonhosted.org/pytz
  - Docs: https://pythonhosted.org/pytz/
</details>





### Update [setuptools](https://pypi.org/project/setuptools) from **40.6.2** to **40.6.3**.


<details>
  <summary>Changelog</summary>
  
  
   ### 40.6.3
   ```
   -------

* 1594: PEP 517 backend no longer declares setuptools as a dependency as it can be assumed.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/setuptools
  - Changelog: https://pyup.io/changelogs/setuptools/
  - Repo: https://github.com/pypa/setuptools
</details>





### Update [Pygments](https://pypi.org/project/Pygments) from **2.3.0** to **2.3.1**.


<details>
  <summary>Changelog</summary>
  
  
   ### 2.3.1
   ```
   -------------
(released Dec 16, 2018)

- Updated lexers:

  * ASM (PR784)
  * Chapel (PR735)
  * Clean (PR621)
  * CSound (PR684)
  * Elm (PR744)
  * Fortran (PR747)
  * GLSL (PR740)
  * Haskell (PR745)
  * Hy (PR754)
  * Igor Pro (PR764)
  * PowerShell (PR705)
  * Python (PR720, 1299, PR715)
  * SLexer (PR680)
  * YAML (PR762, PR724)

- Fix invalid string escape sequences
- Fix `FutureWarning` introduced by regex changes in Python 3.7
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pygments
  - Changelog: https://pyup.io/changelogs/pygments/
  - Homepage: http://pygments.org/
</details>





### Update [google-api-core](https://pypi.org/project/google-api-core) from **1.6.0** to **1.7.0**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-api-core
  - Repo: https://github.com/GoogleCloudPlatform/google-cloud-python
</details>





### Update [google-resumable-media](https://pypi.org/project/google-resumable-media) from **0.3.1** to **0.3.2**.


<details>
  <summary>Changelog</summary>
  
  
   ### 0.3.2
   ```
   12-17-2018 17:31 PST

 Implementation Changes
- Using `str` instead of `repr` for multipart boundary.

 Dependencies
- Making `requests` a strict dependency for the `requests` subpackage.

 Documentation
- Announce deprecation of Python 2.7 ([51](googleapis/google-resumable-media-python#51))
- Fix broken redirect after repository move
- Updating generated static content in docs.

 Internal / Testing Changes
- Modify file not found test to look for the correct error message
- Harden tests so they can run with debug logging statements
- Adding AppVeyor support.
- Marking the version in `master` as `.dev1`.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-resumable-media
  - Changelog: https://pyup.io/changelogs/google-resumable-media/
  - Repo: https://github.com/GoogleCloudPlatform/google-resumable-media-python
</details>





### Update [google-auth](https://pypi.org/project/google-auth) from **1.6.1** to **1.6.2**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.6.2
   ```
   ------

12-17-2018 10:51 PST

Documentation
+++++++++++++

- Announce deprecation of Python 2.7 (`311 &lt;https://github.com/googleapis/google-auth-library-python/pull/311&gt;`_)
- Link all the PRs in CHANGELOG (`307 &lt;https://github.com/googleapis/google-auth-library-python/pull/307&gt;`_)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-auth
  - Changelog: https://pyup.io/changelogs/google-auth/
  - Repo: https://github.com/GoogleCloudPlatform/google-auth-library-python
</details>





### Update [Unidecode](https://pypi.org/project/Unidecode) from **1.0.22** to **1.0.23**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.0.23
   ```
   * Improve transliteration of Hebrew letters (thanks to Alon Bar-Lev)
	* Add transliterations for the phonetic block U+1D00 - U+1D7F
	  (thanks to Oscar Laurent)
	* Transliterate SI &quot;micro&quot; prefix as &quot;u&quot; instead of &quot;micro&quot; in the
	  U+33xx block.
	* Add U+33DE SQUARE V OVER M and U+33DF SQUARE A OVER M.
	* Drop support for Python 2.6 and 3.3 (thanks to Jon Dufresne)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/unidecode
  - Changelog: https://pyup.io/changelogs/unidecode/
</details>





### Update [bcrypt](https://pypi.org/project/bcrypt) from **3.1.4** to **3.1.5**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/bcrypt
  - Repo: https://github.com/pyca/bcrypt/
</details>





### Update [boto3](https://pypi.org/project/boto3) from **1.9.62** to **1.9.74**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.9.74
   ```
   ======

* api-change:``ecs``: [``botocore``] Update ecs client to latest version
* api-change:``devicefarm``: [``botocore``] Update devicefarm client to latest version
   ```
   
  
  
   ### 1.9.73
   ```
   ======

* api-change:``iotanalytics``: [``botocore``] Update iotanalytics client to latest version
   ```
   
  
  
   ### 1.9.72
   ```
   ======

* enhancement:Paginator: [``botocore``] Added over 400 new paginators.
* api-change:``opsworkscm``: [``botocore``] Update opsworkscm client to latest version
   ```
   
  
  
   ### 1.9.71
   ```
   ======

* api-change:``acm-pca``: [``botocore``] Update acm-pca client to latest version
* api-change:``dynamodb``: [``botocore``] Update dynamodb client to latest version
* api-change:``sms-voice``: [``botocore``] Update sms-voice client to latest version
* api-change:``stepfunctions``: [``botocore``] Update stepfunctions client to latest version
   ```
   
  
  
   ### 1.9.70
   ```
   ======

* api-change:``medialive``: [``botocore``] Update medialive client to latest version
* enhancement:EndpointDiscovery: [``botocore``] Add a config option, ``endpoint_discovery_enabled``, for automatically discovering endpoints
* api-change:``comprehend``: [``botocore``] Update comprehend client to latest version
* api-change:``firehose``: [``botocore``] Update firehose client to latest version
* api-change:``transcribe``: [``botocore``] Update transcribe client to latest version
* api-change:``cognito-idp``: [``botocore``] Update cognito-idp client to latest version
   ```
   
  
  
   ### 1.9.69
   ```
   ======

* api-change:``sagemaker``: [``botocore``] Update sagemaker client to latest version
* api-change:``waf-regional``: [``botocore``] Update waf-regional client to latest version
* api-change:``ec2``: [``botocore``] Update ec2 client to latest version
* api-change:``waf``: [``botocore``] Update waf client to latest version
   ```
   
  
  
   ### 1.9.68
   ```
   ======

* api-change:``apigatewayv2``: [``botocore``] Update apigatewayv2 client to latest version
* bugfix:Credentials: [``botocore``] Fixes an issue where credentials would be checked when creating an anonymous client. Fixes `1472 &lt;https://github.com/boto/botocore/issues/1472&gt;`__
* api-change:``ec2``: [``botocore``] Update ec2 client to latest version
* api-change:``elasticbeanstalk``: [``botocore``] Update elasticbeanstalk client to latest version
* api-change:``globalaccelerator``: [``botocore``] Update globalaccelerator client to latest version
* enhancement:StreamingBody: [``botocore``] Support iterating lines from a streaming response body with CRLF line endings
* api-change:``apigatewaymanagementapi``: [``botocore``] Update apigatewaymanagementapi client to latest version
   ```
   
  
  
   ### 1.9.67
   ```
   ======

* api-change:``quicksight``: [``botocore``] Update quicksight client to latest version
* api-change:``ecr``: [``botocore``] Update ecr client to latest version
   ```
   
  
  
   ### 1.9.66
   ```
   ======

* api-change:``alexaforbusiness``: [``botocore``] Update alexaforbusiness client to latest version
* api-change:``redshift``: [``botocore``] Update redshift client to latest version
* api-change:``cloudformation``: [``botocore``] Update cloudformation client to latest version
   ```
   
  
  
   ### 1.9.65
   ```
   ======

* api-change:``organizations``: [``botocore``] Update organizations client to latest version
* api-change:``pinpoint-email``: [``botocore``] Update pinpoint-email client to latest version
   ```
   
  
  
   ### 1.9.64
   ```
   ======

* api-change:``route53``: [``botocore``] Update route53 client to latest version
* api-change:``glue``: [``botocore``] Update glue client to latest version
* api-change:``sagemaker``: [``botocore``] Update sagemaker client to latest version
* api-change:``eks``: [``botocore``] Update eks client to latest version
   ```
   
  
  
   ### 1.9.63
   ```
   ======

* api-change:``mediastore``: [``botocore``] Update mediastore client to latest version
* api-change:``ecs``: [``botocore``] Update ecs client to latest version
* api-change:``connect``: [``botocore``] Update connect client to latest version
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/boto3
  - Changelog: https://pyup.io/changelogs/boto3/
  - Repo: https://github.com/boto/boto3
</details>





### Update [Django](https://pypi.org/project/Django) from **2.0.9** to **2.0.10**.


<details>
  <summary>Changelog</summary>
  
  
   ### 2.0.10
   ```
   ===========================

*January 4, 2019*

Django 2.0.10 fixes a security issue and several bugs in 2.0.9.

CVE-2019-3498: Content spoofing possibility in the default 404 page
-------------------------------------------------------------------

An attacker could craft a malicious URL that could make spoofed content appear
on the default page generated by the ``django.views.defaults.page_not_found()``
view.

The URL path is no longer displayed in the default 404 template and the
``request_path`` context variable is now quoted to fix the issue for custom
templates that use the path.

Bugfixes
========

* Prevented repetitive calls to ``geos_version_tuple()`` in the ``WKBWriter``
  class in an attempt to fix a random crash involving ``LooseVersion`` since
  Django 2.0.6 (🎫`29959`).

* Fixed a schema corruption issue on SQLite 3.26+. You might have to drop and
  rebuild your SQLite database if you applied a migration while using an older
  version of Django with SQLite 3.26 or later (🎫`29182`).

* Prevented SQLite schema alterations while foreign key checks are enabled to
  avoid the possibility of schema corruption (🎫`30023`).


==========================
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/django
  - Changelog: https://pyup.io/changelogs/django/
  - Homepage: https://www.djangoproject.com/
</details>





### Update [gevent](https://pypi.org/project/gevent) from **1.3.7** to **1.4.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.4.0
   ```
   ==================

- Build with Cython 0.29 in &#39;3str&#39; mode.

- Test with PyPy 6.0 on Windows.

- Add support for application-wide callbacks when ``Greenlet`` objects
  are started. See :pr:`1289`, provided by Yury Selivanov.

- Fix consuming a single ready object using
  ``next(gevent.iwait(objs))``. Previously such a construction would
  hang because `iter` was not called. See :pr:`1288`, provided by Josh
  Snyder. This is not recommended, though, as unwaited objects will
  have dangling links (but see next item).

- Make `gevent.iwait` return an iterator that can now also be used as
  a context manager. If you&#39;ll only be consuming part of the iterator,
  use it in a ``with`` block to avoid leaking resources. See
  :pr:`1290`, provided by Josh Snyder.

- Fix semaphores to immediately notify links if they are ready and
  ``rawlink()`` is called. This behaves like ``Event`` and
  ``AsyncEvent``. Note that the order in which semaphore links are
  called is not specified. See :issue:`1287`, reported by Dan Milon.

- Improve safety of handling exceptions during interpreter shutdown.
  See :issue:`1295` reported by BobDenar1212.

- Remove the deprecated ability to specify ``GEVENT_RESOLVER`` and
  other importable settings as a ``path/to/a/package.module.item``.
  This had race conditions and didn&#39;t work with complicated resolver
  implementations. Place the required package or module on `sys.path`
  first.

- Reduce the chances that using the blocking monitor functionality
  could result in apparently random ``SystemError:
  Objects/tupleobject.c: bad argument to internal function``. Reported
  in :issue:`1302` by Ulrich Petri.

- Refactored the gevent test runner and test suite to make them more
  reusable. In particular, the tests are now run with ``python -m
  gevent.tests``. See :issue:`1293`.

- Make a monkey-patched ``socket.getaddrinfo`` return socket module
  enums instead of plain integers for the socket type and address
  family on Python 3. See :issue:`1310` reported by TheYOSH.

- Make gevent&#39;s pywsgi server set the non-standard environment value
  ``wsgi.input_terminated`` to True. See :issue:`1308`.

- Make `gevent.util.assert_switches` produce more informative messages
  when the assertion fails.

- Python 2: If a `gevent.socket` was closed asynchronously (in a
  different greenlet or a hub callback), `AttributeError` could result
  if the socket was already in use. Now the correct socket.error
  should be raised.

- Fix :meth:`gevent.threadpool.ThreadPool.join` raising a
  `UserWarning` when using the libuv backend. Reported in
  :issue:`1321` by ZeroNet.

- Fix ``FileObjectPosix.seek`` raising `OSError` when it should have
  been `IOError` on Python 2. Reported by, and PR by, Ricardo Kirkner.
  See :issue:`1323`.

- Upgrade libuv from 1.23.2 to 1.24.0.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/gevent
  - Changelog: https://pyup.io/changelogs/gevent/
  - Homepage: http://www.gevent.org/
</details>





### Update [pyasn1](https://pypi.org/project/pyasn1) from **0.4.4** to **0.4.5**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pyasn1
  - Changelog: https://pyup.io/changelogs/pyasn1/
  - Repo: https://github.com/etingof/pyasn1
</details>





### Update [pyasn1-modules](https://pypi.org/project/pyasn1-modules) from **0.2.2** to **0.2.3**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pyasn1-modules
  - Changelog: https://pyup.io/changelogs/pyasn1-modules/
  - Repo: https://github.com/etingof/pyasn1-modules
</details>





### Update [pytest](https://pypi.org/project/pytest) from **4.0.1** to **4.1.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 4.1.0
   ```
   =========================

Removals
--------

- `2169 &lt;https://github.com/pytest-dev/pytest/issues/2169&gt;`_: ``pytest.mark.parametrize``: in previous versions, errors raised by id functions were suppressed and changed into warnings. Now the exceptions are propagated, along with a pytest message informing the node, parameter value and index where the exception occurred.


- `3078 &lt;https://github.com/pytest-dev/pytest/issues/3078&gt;`_: Remove legacy internal warnings system: ``config.warn``, ``Node.warn``. The ``pytest_logwarning`` now issues a warning when implemented.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlconfig-warn-and-node-warn&gt;`__ on information on how to update your code.


- `3079 &lt;https://github.com/pytest-dev/pytest/issues/3079&gt;`_: Removed support for yield tests - they are fundamentally broken because they don&#39;t support fixtures properly since collection and test execution were separated.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlyield-tests&gt;`__ on information on how to update your code.


- `3082 &lt;https://github.com/pytest-dev/pytest/issues/3082&gt;`_: Removed support for applying marks directly to values in ``pytest.mark.parametrize``. Use ``pytest.param`` instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlmarks-in-pytest-mark-parametrize&gt;`__ on information on how to update your code.


- `3083 &lt;https://github.com/pytest-dev/pytest/issues/3083&gt;`_: Removed ``Metafunc.addcall``. This was the predecessor mechanism to ``pytest.mark.parametrize``.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlmetafunc-addcall&gt;`__ on information on how to update your code.


- `3085 &lt;https://github.com/pytest-dev/pytest/issues/3085&gt;`_: Removed support for passing strings to ``pytest.main``. Now, always pass a list of strings instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpassing-command-line-string-to-pytest-main&gt;`__ on information on how to update your code.


- `3086 &lt;https://github.com/pytest-dev/pytest/issues/3086&gt;`_: ``[pytest]`` section in **setup.cfg** files is not longer supported, use ``[tool:pytest]`` instead. ``setup.cfg`` files
  are meant for use with ``distutils``, and a section named ``pytest`` has notoriously been a source of conflicts and bugs.

  Note that for **pytest.ini** and **tox.ini** files the section remains ``[pytest]``.


- `3616 &lt;https://github.com/pytest-dev/pytest/issues/3616&gt;`_: Removed the deprecated compat properties for ``node.Class/Function/Module`` - use ``pytest.Class/Function/Module`` now.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlinternal-classes-accessed-through-node&gt;`__ on information on how to update your code.


- `4421 &lt;https://github.com/pytest-dev/pytest/issues/4421&gt;`_: Removed the implementation of the ``pytest_namespace`` hook.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-namespace&gt;`__ on information on how to update your code.


- `4489 &lt;https://github.com/pytest-dev/pytest/issues/4489&gt;`_: Removed ``request.cached_setup``. This was the predecessor mechanism to modern fixtures.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlcached-setup&gt;`__ on information on how to update your code.


- `4535 &lt;https://github.com/pytest-dev/pytest/issues/4535&gt;`_: Removed the deprecated ``PyCollector.makeitem`` method. This method was made public by mistake a long time ago.


- `4543 &lt;https://github.com/pytest-dev/pytest/issues/4543&gt;`_: Removed support to define fixtures using the ``pytest_funcarg__`` prefix. Use the ``pytest.fixture`` decorator instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-funcarg-prefix&gt;`__ on information on how to update your code.


- `4545 &lt;https://github.com/pytest-dev/pytest/issues/4545&gt;`_: Calling fixtures directly is now always an error instead of a warning.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlcalling-fixtures-directly&gt;`__ on information on how to update your code.


- `4546 &lt;https://github.com/pytest-dev/pytest/issues/4546&gt;`_: Remove ``Node.get_marker(name)`` the return value was not usable for more than a existence check.

  Use ``Node.get_closest_marker(name)`` as a replacement.


- `4547 &lt;https://github.com/pytest-dev/pytest/issues/4547&gt;`_: The deprecated ``record_xml_property`` fixture has been removed, use the more generic ``record_property`` instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlrecord-xml-property&gt;`__ for more information.


- `4548 &lt;https://github.com/pytest-dev/pytest/issues/4548&gt;`_: An error is now raised if the ``pytest_plugins`` variable is defined in a non-top-level ``conftest.py`` file (i.e., not residing in the ``rootdir``).

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-plugins-in-non-top-level-conftest-files&gt;`__ for more information.


- `891 &lt;https://github.com/pytest-dev/pytest/issues/891&gt;`_: Remove ``testfunction.markername`` attributes - use ``Node.iter_markers(name=None)`` to iterate them.



Deprecations
------------

- `3050 &lt;https://github.com/pytest-dev/pytest/issues/3050&gt;`_: Deprecated the ``pytest.config`` global.

  See https://docs.pytest.org/en/latest/deprecations.htmlpytest-config-global for rationale.


- `3974 &lt;https://github.com/pytest-dev/pytest/issues/3974&gt;`_: Passing the ``message`` parameter of ``pytest.raises`` now issues a ``DeprecationWarning``.

  It is a common mistake to think this parameter will match the exception message, while in fact
  it only serves to provide a custom message in case the ``pytest.raises`` check fails. To avoid this
  mistake and because it is believed to be little used, pytest is deprecating it without providing
  an alternative for the moment.

  If you have concerns about this, please comment on `issue 3974 &lt;https://github.com/pytest-dev/pytest/issues/3974&gt;`__.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Deprecated ``raises(..., &#39;code(as_a_string)&#39;)`` and ``warns(..., &#39;code(as_a_string)&#39;)``.

  See https://docs.pytest.org/en/latest/deprecations.htmlraises-warns-exec for rationale and examples.



Features
--------

- `3191 &lt;https://github.com/pytest-dev/pytest/issues/3191&gt;`_: A warning is now issued when assertions are made for ``None``.

  This is a common source of confusion among new users, which write:

  .. code-block:: python

      assert mocked_object.assert_called_with(3, 4, 5, key=&quot;value&quot;)

  When they should write:

  .. code-block:: python

      mocked_object.assert_called_with(3, 4, 5, key=&quot;value&quot;)

  Because the ``assert_called_with`` method of mock objects already executes an assertion.

  This warning will not be issued when ``None`` is explicitly checked. An assertion like:

  .. code-block:: python

      assert variable is None

  will not issue the warning.


- `3632 &lt;https://github.com/pytest-dev/pytest/issues/3632&gt;`_: Richer equality comparison introspection on ``AssertionError`` for objects created using `attrs &lt;http://www.attrs.org/en/stable/&gt;`__ or `dataclasses &lt;https://docs.python.org/3/library/dataclasses.html&gt;`_ (Python 3.7+, `backported to 3.6 &lt;https://pypi.org/project/dataclasses&gt;`__).


- `4278 &lt;https://github.com/pytest-dev/pytest/issues/4278&gt;`_: ``CACHEDIR.TAG`` files are now created inside cache directories.

  Those files are part of the `Cache Directory Tagging Standard &lt;http://www.bford.info/cachedir/spec.html&gt;`__, and can
  be used by backup or synchronization programs to identify pytest&#39;s cache directory as such.


- `4292 &lt;https://github.com/pytest-dev/pytest/issues/4292&gt;`_: ``pytest.outcomes.Exit`` is derived from ``SystemExit`` instead of ``KeyboardInterrupt``. This allows us to better handle ``pdb`` exiting.


- `4371 &lt;https://github.com/pytest-dev/pytest/issues/4371&gt;`_: Updated the ``--collect-only`` option to display test descriptions when ran using ``--verbose``.


- `4386 &lt;https://github.com/pytest-dev/pytest/issues/4386&gt;`_: Restructured ``ExceptionInfo`` object construction and ensure incomplete instances have a ``repr``/``str``.


- `4416 &lt;https://github.com/pytest-dev/pytest/issues/4416&gt;`_: pdb: added support for keyword arguments with ``pdb.set_trace``.

  It handles ``header`` similar to Python 3.7 does it, and forwards any
  other keyword arguments to the ``Pdb`` constructor.

  This allows for ``__import__(&quot;pdb&quot;).set_trace(skip=[&quot;foo.*&quot;])``.


- `4483 &lt;https://github.com/pytest-dev/pytest/issues/4483&gt;`_: Added ini parameter ``junit_duration_report`` to optionally report test call durations, excluding setup and teardown times.

  The JUnit XML specification and the default pytest behavior is to include setup and teardown times in the test duration
  report. You can include just the call durations instead (excluding setup and teardown) by adding this to your ``pytest.ini`` file:

  .. code-block:: ini

      [pytest]
      junit_duration_report = call


- `4532 &lt;https://github.com/pytest-dev/pytest/issues/4532&gt;`_: ``-ra`` now will show errors and failures last, instead of as the first items in the summary.

  This makes it easier to obtain a list of errors and failures to run tests selectively.


- `4599 &lt;https://github.com/pytest-dev/pytest/issues/4599&gt;`_: ``pytest.importorskip`` now supports a ``reason`` parameter, which will be shown when the
  requested module cannot be imported.



Bug Fixes
---------

- `3532 &lt;https://github.com/pytest-dev/pytest/issues/3532&gt;`_: ``-p`` now accepts its argument without a space between the value, for example ``-pmyplugin``.


- `4327 &lt;https://github.com/pytest-dev/pytest/issues/4327&gt;`_: ``approx`` again works with more generic containers, more precisely instances of ``Iterable`` and ``Sized`` instead of more restrictive ``Sequence``.


- `4397 &lt;https://github.com/pytest-dev/pytest/issues/4397&gt;`_: Ensure that node ids are printable.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Fixed ``raises(..., &#39;code(string)&#39;)`` frame filename.


- `4458 &lt;https://github.com/pytest-dev/pytest/issues/4458&gt;`_: Display actual test ids in ``--collect-only``.



Improved Documentation
----------------------

- `4557 &lt;https://github.com/pytest-dev/pytest/issues/4557&gt;`_: Markers example documentation page updated to support latest pytest version.


- `4558 &lt;https://github.com/pytest-dev/pytest/issues/4558&gt;`_: Update cache documentation example to correctly show cache hit and miss.


- `4580 &lt;https://github.com/pytest-dev/pytest/issues/4580&gt;`_: Improved detailed summary report documentation.



Trivial/Internal Changes
------------------------

- `4447 &lt;https://github.com/pytest-dev/pytest/issues/4447&gt;`_: Changed the deprecation type of ``--result-log`` to ``PytestDeprecationWarning``.

  It was decided to remove this feature at the next major revision.
   ```
   
  
  
   ### 4.0.2
   ```
   =========================

Bug Fixes
---------

- `4265 &lt;https://github.com/pytest-dev/pytest/issues/4265&gt;`_: Validate arguments from the ``PYTEST_ADDOPTS`` environment variable and the ``addopts`` ini option separately.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Fix ``raises(..., &#39;code(string)&#39;)`` frame filename.


- `4500 &lt;https://github.com/pytest-dev/pytest/issues/4500&gt;`_: When a fixture yields and a log call is made after the test runs, and, if the test is interrupted, capture attributes are ``None``.


- `4538 &lt;https://github.com/pytest-dev/pytest/issues/4538&gt;`_: Raise ``TypeError`` for ``with raises(..., match=&lt;non-None falsey value&gt;)``.



Improved Documentation
----------------------

- `1495 &lt;https://github.com/pytest-dev/pytest/issues/1495&gt;`_: Document common doctest fixture directory tree structure pitfalls
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pytest
  - Changelog: https://pyup.io/changelogs/pytest/
  - Homepage: https://docs.pytest.org/en/latest/
</details>





### Update [raven](https://pypi.org/project/raven) from **6.9.0** to **6.10.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 6.10.0
   ```
   ------

* [Core] Fixed stackframes in some situations being in inverse order.
* [Flask] Fix wrong exception handling logic (accidentally relied on Flask internals).
* [Core] No longer send NaN local vars as non-standard JSON.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/raven
  - Changelog: https://pyup.io/changelogs/raven/
  - Repo: https://github.com/getsentry/raven-python
</details>





### Update [backoff](https://pypi.org/project/backoff) from **1.7.1** to **1.8.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.8.0
   ```
   Changed

- Give up on StopIteration raised in wait generators
- Iterable intervals for constant wait_gen for predefined wait sequences
- Nullary jitter signature deprecation warning
- Custom loggers
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/backoff
  - Changelog: https://pyup.io/changelogs/backoff/
  - Repo: https://github.com/litl/backoff
</details>





### Update [google-cloud-storage](https://pypi.org/project/google-cloud-storage) from **1.13.0** to **1.13.2**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-cloud-storage
  - Repo: https://github.com/GoogleCloudPlatform/google-cloud-python
</details>





### Update [kinto-http](https://pypi.org/project/kinto-http) from **10.1.0** to **10.2.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 10.2.0
   ```
   ===================

**New features**

- Created new method on client to get paginated records ``get_paginated_records``. (175)
- Allow additional querystring params in `get_*()` methods
   ```
   
  
  
   ### 10.1.1
   ```
   ===================

**Bug fixes**

- Fix JSON support for `in_` and `exclude_`. (188)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/kinto-http
  - Changelog: https://pyup.io/changelogs/kinto-http/
  - Repo: https://github.com/Kinto/kinto-http.py/
</details>





### Update [Sphinx](https://pypi.org/project/Sphinx) from **1.8.2** to **1.8.3**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.8.3
   ```
   ==============================

Dependencies
------------

Incompatible changes
--------------------

Deprecated
----------

Features added
--------------

* LaTeX: it is possible to insert custom material to appear on back of title
  page, see discussion of ``&#39;maketitle&#39;`` key of :confval:`latex_elements`
  (``&#39;manual&#39;`` docclass only)

Bugs fixed
----------

* 5725: mathjax: Use CDN URL for &quot;latest&quot; version by default
* 5460: html search does not work with some 3rd party themes
* 5520: LaTeX, caption package incompatibility since Sphinx 1.6
* 5614: autodoc: incremental build is broken when builtin modules are imported
* 5627: qthelp: index.html missing in QtHelp
* 5659: linkcheck: crashes for a hyperlink containing multibyte character
* 5754: DOC: Fix some mistakes in :doc:`/latex`
* 5810: LaTeX: sphinxVerbatim requires explicit &quot;hllines&quot; set-up since 1.6.6
  (refs: 1238)
* 5636: C++, fix parsing of floating point literals.
* 5496 (again): C++, fix assertion in partial builds with duplicates.
* 5724: quickstart: sphinx-quickstart fails when $LC_ALL is empty
* 1956: Default conf.py is not PEP8-compliant
* 5849: LaTeX: document class ``\maketitle`` is overwritten with no
  possibility to use original meaning in place of Sphinx custom one
* 5834: apidoc: wrong help for ``--tocfile``
* 5800: todo: crashed if todo is defined in TextElement
* 5846: htmlhelp: convert hex escaping to decimal escaping in .hhc/.hhk files

Testing
--------
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/sphinx
  - Changelog: https://pyup.io/changelogs/sphinx/
  - Homepage: http://sphinx-doc.org/
</details>







Co-authored-by: pyup-bot <github-bot@pyup.io>
Co-authored-by: Peter Bengtsson <mail@peterbe.com>

bors bot added a commit to mozilla/normandy that referenced this pull request Jan 9, 2019

Merge #1680
1680: Scheduled weekly dependency update for week 01 r=mythmon a=pyup-bot






### Update [botocore](https://pypi.org/project/botocore) from **1.12.62** to **1.12.74**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.12.74
   ```
   =======

* api-change:``ecs``: Update ecs client to latest version
* api-change:``devicefarm``: Update devicefarm client to latest version
   ```
   
  
  
   ### 1.12.73
   ```
   =======

* api-change:``iotanalytics``: Update iotanalytics client to latest version
   ```
   
  
  
   ### 1.12.72
   ```
   =======

* enhancement:Paginator: Added over 400 new paginators.
* api-change:``opsworkscm``: Update opsworkscm client to latest version
   ```
   
  
  
   ### 1.12.71
   ```
   =======

* api-change:``acm-pca``: Update acm-pca client to latest version
* api-change:``dynamodb``: Update dynamodb client to latest version
* api-change:``sms-voice``: Update sms-voice client to latest version
* api-change:``stepfunctions``: Update stepfunctions client to latest version
   ```
   
  
  
   ### 1.12.70
   ```
   =======

* api-change:``medialive``: Update medialive client to latest version
* enhancement:EndpointDiscovery: Add a config option, ``endpoint_discovery_enabled``, for automatically discovering endpoints
* api-change:``comprehend``: Update comprehend client to latest version
* api-change:``firehose``: Update firehose client to latest version
* api-change:``transcribe``: Update transcribe client to latest version
* api-change:``cognito-idp``: Update cognito-idp client to latest version
   ```
   
  
  
   ### 1.12.69
   ```
   =======

* api-change:``sagemaker``: Update sagemaker client to latest version
* api-change:``waf-regional``: Update waf-regional client to latest version
* api-change:``ec2``: Update ec2 client to latest version
* api-change:``waf``: Update waf client to latest version
   ```
   
  
  
   ### 1.12.68
   ```
   =======

* api-change:``apigatewayv2``: Update apigatewayv2 client to latest version
* bugfix:Credentials: Fixes an issue where credentials would be checked when creating an anonymous client. Fixes `1472 &lt;https://github.com/boto/botocore/issues/1472&gt;`__
* api-change:``ec2``: Update ec2 client to latest version
* api-change:``elasticbeanstalk``: Update elasticbeanstalk client to latest version
* api-change:``globalaccelerator``: Update globalaccelerator client to latest version
* enhancement:StreamingBody: Support iterating lines from a streaming response body with CRLF line endings
* api-change:``apigatewaymanagementapi``: Update apigatewaymanagementapi client to latest version
   ```
   
  
  
   ### 1.12.67
   ```
   =======

* api-change:``quicksight``: Update quicksight client to latest version
* api-change:``ecr``: Update ecr client to latest version
   ```
   
  
  
   ### 1.12.66
   ```
   =======

* api-change:``alexaforbusiness``: Update alexaforbusiness client to latest version
* api-change:``redshift``: Update redshift client to latest version
* api-change:``cloudformation``: Update cloudformation client to latest version
   ```
   
  
  
   ### 1.12.65
   ```
   =======

* api-change:``organizations``: Update organizations client to latest version
* api-change:``pinpoint-email``: Update pinpoint-email client to latest version
   ```
   
  
  
   ### 1.12.64
   ```
   =======

* api-change:``route53``: Update route53 client to latest version
* api-change:``glue``: Update glue client to latest version
* api-change:``sagemaker``: Update sagemaker client to latest version
* api-change:``eks``: Update eks client to latest version
   ```
   
  
  
   ### 1.12.63
   ```
   =======

* api-change:``mediastore``: Update mediastore client to latest version
* api-change:``ecs``: Update ecs client to latest version
* api-change:``connect``: Update connect client to latest version
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/botocore
  - Changelog: https://pyup.io/changelogs/botocore/
  - Repo: https://github.com/boto/botocore
</details>





### Update [Faker](https://pypi.org/project/Faker) from **1.0.0** to **1.0.1**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.0.1
   ```
   * 1 minor enhancement
    * Added safe_email method to get someaddressexample.com [Kazimierz Kiełkowicz]
* 1 bug fix:
    * Use the locale fallback properly when parsing string formats
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/faker
  - Changelog: https://pyup.io/changelogs/faker/
  - Repo: https://github.com/joke2k/faker
</details>





### Update [more-itertools](https://pypi.org/project/more-itertools) from **4.3.0** to **5.0.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 5.0.0
   ```
   See PR 252 for notes.
   ```
   
  
  
   ### 4.3.1
   ```
   This is [version 4.3.0](https://github.com/erikrose/more-itertools/releases/tag/4.3.0) plus PR 226 . There is no corresponding PyPI release; this is just to fix the docs on RTD.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/more-itertools
  - Changelog: https://pyup.io/changelogs/more-itertools/
  - Repo: https://github.com/erikrose/more-itertools
  - Docs: https://pythonhosted.org/more-itertools/
</details>





### Update [pytz](https://pypi.org/project/pytz) from **2018.7** to **2018.9**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pytz
  - Homepage: http://pythonhosted.org/pytz
  - Docs: https://pythonhosted.org/pytz/
</details>





### Update [setuptools](https://pypi.org/project/setuptools) from **40.6.2** to **40.6.3**.


<details>
  <summary>Changelog</summary>
  
  
   ### 40.6.3
   ```
   -------

* 1594: PEP 517 backend no longer declares setuptools as a dependency as it can be assumed.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/setuptools
  - Changelog: https://pyup.io/changelogs/setuptools/
  - Repo: https://github.com/pypa/setuptools
</details>





### Update [Pygments](https://pypi.org/project/Pygments) from **2.3.0** to **2.3.1**.


<details>
  <summary>Changelog</summary>
  
  
   ### 2.3.1
   ```
   -------------
(released Dec 16, 2018)

- Updated lexers:

  * ASM (PR784)
  * Chapel (PR735)
  * Clean (PR621)
  * CSound (PR684)
  * Elm (PR744)
  * Fortran (PR747)
  * GLSL (PR740)
  * Haskell (PR745)
  * Hy (PR754)
  * Igor Pro (PR764)
  * PowerShell (PR705)
  * Python (PR720, 1299, PR715)
  * SLexer (PR680)
  * YAML (PR762, PR724)

- Fix invalid string escape sequences
- Fix `FutureWarning` introduced by regex changes in Python 3.7
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pygments
  - Changelog: https://pyup.io/changelogs/pygments/
  - Homepage: http://pygments.org/
</details>





### Update [google-api-core](https://pypi.org/project/google-api-core) from **1.6.0** to **1.7.0**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-api-core
  - Repo: https://github.com/GoogleCloudPlatform/google-cloud-python
</details>





### Update [google-resumable-media](https://pypi.org/project/google-resumable-media) from **0.3.1** to **0.3.2**.


<details>
  <summary>Changelog</summary>
  
  
   ### 0.3.2
   ```
   12-17-2018 17:31 PST

 Implementation Changes
- Using `str` instead of `repr` for multipart boundary.

 Dependencies
- Making `requests` a strict dependency for the `requests` subpackage.

 Documentation
- Announce deprecation of Python 2.7 ([51](googleapis/google-resumable-media-python#51))
- Fix broken redirect after repository move
- Updating generated static content in docs.

 Internal / Testing Changes
- Modify file not found test to look for the correct error message
- Harden tests so they can run with debug logging statements
- Adding AppVeyor support.
- Marking the version in `master` as `.dev1`.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-resumable-media
  - Changelog: https://pyup.io/changelogs/google-resumable-media/
  - Repo: https://github.com/GoogleCloudPlatform/google-resumable-media-python
</details>





### Update [google-auth](https://pypi.org/project/google-auth) from **1.6.1** to **1.6.2**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.6.2
   ```
   ------

12-17-2018 10:51 PST

Documentation
+++++++++++++

- Announce deprecation of Python 2.7 (`311 &lt;https://github.com/googleapis/google-auth-library-python/pull/311&gt;`_)
- Link all the PRs in CHANGELOG (`307 &lt;https://github.com/googleapis/google-auth-library-python/pull/307&gt;`_)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-auth
  - Changelog: https://pyup.io/changelogs/google-auth/
  - Repo: https://github.com/GoogleCloudPlatform/google-auth-library-python
</details>





### Update [Unidecode](https://pypi.org/project/Unidecode) from **1.0.22** to **1.0.23**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.0.23
   ```
   * Improve transliteration of Hebrew letters (thanks to Alon Bar-Lev)
	* Add transliterations for the phonetic block U+1D00 - U+1D7F
	  (thanks to Oscar Laurent)
	* Transliterate SI &quot;micro&quot; prefix as &quot;u&quot; instead of &quot;micro&quot; in the
	  U+33xx block.
	* Add U+33DE SQUARE V OVER M and U+33DF SQUARE A OVER M.
	* Drop support for Python 2.6 and 3.3 (thanks to Jon Dufresne)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/unidecode
  - Changelog: https://pyup.io/changelogs/unidecode/
</details>





### Update [bcrypt](https://pypi.org/project/bcrypt) from **3.1.4** to **3.1.5**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/bcrypt
  - Repo: https://github.com/pyca/bcrypt/
</details>





### Update [boto3](https://pypi.org/project/boto3) from **1.9.62** to **1.9.74**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.9.74
   ```
   ======

* api-change:``ecs``: [``botocore``] Update ecs client to latest version
* api-change:``devicefarm``: [``botocore``] Update devicefarm client to latest version
   ```
   
  
  
   ### 1.9.73
   ```
   ======

* api-change:``iotanalytics``: [``botocore``] Update iotanalytics client to latest version
   ```
   
  
  
   ### 1.9.72
   ```
   ======

* enhancement:Paginator: [``botocore``] Added over 400 new paginators.
* api-change:``opsworkscm``: [``botocore``] Update opsworkscm client to latest version
   ```
   
  
  
   ### 1.9.71
   ```
   ======

* api-change:``acm-pca``: [``botocore``] Update acm-pca client to latest version
* api-change:``dynamodb``: [``botocore``] Update dynamodb client to latest version
* api-change:``sms-voice``: [``botocore``] Update sms-voice client to latest version
* api-change:``stepfunctions``: [``botocore``] Update stepfunctions client to latest version
   ```
   
  
  
   ### 1.9.70
   ```
   ======

* api-change:``medialive``: [``botocore``] Update medialive client to latest version
* enhancement:EndpointDiscovery: [``botocore``] Add a config option, ``endpoint_discovery_enabled``, for automatically discovering endpoints
* api-change:``comprehend``: [``botocore``] Update comprehend client to latest version
* api-change:``firehose``: [``botocore``] Update firehose client to latest version
* api-change:``transcribe``: [``botocore``] Update transcribe client to latest version
* api-change:``cognito-idp``: [``botocore``] Update cognito-idp client to latest version
   ```
   
  
  
   ### 1.9.69
   ```
   ======

* api-change:``sagemaker``: [``botocore``] Update sagemaker client to latest version
* api-change:``waf-regional``: [``botocore``] Update waf-regional client to latest version
* api-change:``ec2``: [``botocore``] Update ec2 client to latest version
* api-change:``waf``: [``botocore``] Update waf client to latest version
   ```
   
  
  
   ### 1.9.68
   ```
   ======

* api-change:``apigatewayv2``: [``botocore``] Update apigatewayv2 client to latest version
* bugfix:Credentials: [``botocore``] Fixes an issue where credentials would be checked when creating an anonymous client. Fixes `1472 &lt;https://github.com/boto/botocore/issues/1472&gt;`__
* api-change:``ec2``: [``botocore``] Update ec2 client to latest version
* api-change:``elasticbeanstalk``: [``botocore``] Update elasticbeanstalk client to latest version
* api-change:``globalaccelerator``: [``botocore``] Update globalaccelerator client to latest version
* enhancement:StreamingBody: [``botocore``] Support iterating lines from a streaming response body with CRLF line endings
* api-change:``apigatewaymanagementapi``: [``botocore``] Update apigatewaymanagementapi client to latest version
   ```
   
  
  
   ### 1.9.67
   ```
   ======

* api-change:``quicksight``: [``botocore``] Update quicksight client to latest version
* api-change:``ecr``: [``botocore``] Update ecr client to latest version
   ```
   
  
  
   ### 1.9.66
   ```
   ======

* api-change:``alexaforbusiness``: [``botocore``] Update alexaforbusiness client to latest version
* api-change:``redshift``: [``botocore``] Update redshift client to latest version
* api-change:``cloudformation``: [``botocore``] Update cloudformation client to latest version
   ```
   
  
  
   ### 1.9.65
   ```
   ======

* api-change:``organizations``: [``botocore``] Update organizations client to latest version
* api-change:``pinpoint-email``: [``botocore``] Update pinpoint-email client to latest version
   ```
   
  
  
   ### 1.9.64
   ```
   ======

* api-change:``route53``: [``botocore``] Update route53 client to latest version
* api-change:``glue``: [``botocore``] Update glue client to latest version
* api-change:``sagemaker``: [``botocore``] Update sagemaker client to latest version
* api-change:``eks``: [``botocore``] Update eks client to latest version
   ```
   
  
  
   ### 1.9.63
   ```
   ======

* api-change:``mediastore``: [``botocore``] Update mediastore client to latest version
* api-change:``ecs``: [``botocore``] Update ecs client to latest version
* api-change:``connect``: [``botocore``] Update connect client to latest version
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/boto3
  - Changelog: https://pyup.io/changelogs/boto3/
  - Repo: https://github.com/boto/boto3
</details>





### Update [Django](https://pypi.org/project/Django) from **2.0.9** to **2.0.10**.


<details>
  <summary>Changelog</summary>
  
  
   ### 2.0.10
   ```
   ===========================

*January 4, 2019*

Django 2.0.10 fixes a security issue and several bugs in 2.0.9.

CVE-2019-3498: Content spoofing possibility in the default 404 page
-------------------------------------------------------------------

An attacker could craft a malicious URL that could make spoofed content appear
on the default page generated by the ``django.views.defaults.page_not_found()``
view.

The URL path is no longer displayed in the default 404 template and the
``request_path`` context variable is now quoted to fix the issue for custom
templates that use the path.

Bugfixes
========

* Prevented repetitive calls to ``geos_version_tuple()`` in the ``WKBWriter``
  class in an attempt to fix a random crash involving ``LooseVersion`` since
  Django 2.0.6 (🎫`29959`).

* Fixed a schema corruption issue on SQLite 3.26+. You might have to drop and
  rebuild your SQLite database if you applied a migration while using an older
  version of Django with SQLite 3.26 or later (🎫`29182`).

* Prevented SQLite schema alterations while foreign key checks are enabled to
  avoid the possibility of schema corruption (🎫`30023`).


==========================
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/django
  - Changelog: https://pyup.io/changelogs/django/
  - Homepage: https://www.djangoproject.com/
</details>





### Update [gevent](https://pypi.org/project/gevent) from **1.3.7** to **1.4.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.4.0
   ```
   ==================

- Build with Cython 0.29 in &#39;3str&#39; mode.

- Test with PyPy 6.0 on Windows.

- Add support for application-wide callbacks when ``Greenlet`` objects
  are started. See :pr:`1289`, provided by Yury Selivanov.

- Fix consuming a single ready object using
  ``next(gevent.iwait(objs))``. Previously such a construction would
  hang because `iter` was not called. See :pr:`1288`, provided by Josh
  Snyder. This is not recommended, though, as unwaited objects will
  have dangling links (but see next item).

- Make `gevent.iwait` return an iterator that can now also be used as
  a context manager. If you&#39;ll only be consuming part of the iterator,
  use it in a ``with`` block to avoid leaking resources. See
  :pr:`1290`, provided by Josh Snyder.

- Fix semaphores to immediately notify links if they are ready and
  ``rawlink()`` is called. This behaves like ``Event`` and
  ``AsyncEvent``. Note that the order in which semaphore links are
  called is not specified. See :issue:`1287`, reported by Dan Milon.

- Improve safety of handling exceptions during interpreter shutdown.
  See :issue:`1295` reported by BobDenar1212.

- Remove the deprecated ability to specify ``GEVENT_RESOLVER`` and
  other importable settings as a ``path/to/a/package.module.item``.
  This had race conditions and didn&#39;t work with complicated resolver
  implementations. Place the required package or module on `sys.path`
  first.

- Reduce the chances that using the blocking monitor functionality
  could result in apparently random ``SystemError:
  Objects/tupleobject.c: bad argument to internal function``. Reported
  in :issue:`1302` by Ulrich Petri.

- Refactored the gevent test runner and test suite to make them more
  reusable. In particular, the tests are now run with ``python -m
  gevent.tests``. See :issue:`1293`.

- Make a monkey-patched ``socket.getaddrinfo`` return socket module
  enums instead of plain integers for the socket type and address
  family on Python 3. See :issue:`1310` reported by TheYOSH.

- Make gevent&#39;s pywsgi server set the non-standard environment value
  ``wsgi.input_terminated`` to True. See :issue:`1308`.

- Make `gevent.util.assert_switches` produce more informative messages
  when the assertion fails.

- Python 2: If a `gevent.socket` was closed asynchronously (in a
  different greenlet or a hub callback), `AttributeError` could result
  if the socket was already in use. Now the correct socket.error
  should be raised.

- Fix :meth:`gevent.threadpool.ThreadPool.join` raising a
  `UserWarning` when using the libuv backend. Reported in
  :issue:`1321` by ZeroNet.

- Fix ``FileObjectPosix.seek`` raising `OSError` when it should have
  been `IOError` on Python 2. Reported by, and PR by, Ricardo Kirkner.
  See :issue:`1323`.

- Upgrade libuv from 1.23.2 to 1.24.0.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/gevent
  - Changelog: https://pyup.io/changelogs/gevent/
  - Homepage: http://www.gevent.org/
</details>





### Update [pyasn1](https://pypi.org/project/pyasn1) from **0.4.4** to **0.4.5**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pyasn1
  - Changelog: https://pyup.io/changelogs/pyasn1/
  - Repo: https://github.com/etingof/pyasn1
</details>





### Update [pyasn1-modules](https://pypi.org/project/pyasn1-modules) from **0.2.2** to **0.2.3**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pyasn1-modules
  - Changelog: https://pyup.io/changelogs/pyasn1-modules/
  - Repo: https://github.com/etingof/pyasn1-modules
</details>





### Update [pytest](https://pypi.org/project/pytest) from **4.0.1** to **4.1.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 4.1.0
   ```
   =========================

Removals
--------

- `2169 &lt;https://github.com/pytest-dev/pytest/issues/2169&gt;`_: ``pytest.mark.parametrize``: in previous versions, errors raised by id functions were suppressed and changed into warnings. Now the exceptions are propagated, along with a pytest message informing the node, parameter value and index where the exception occurred.


- `3078 &lt;https://github.com/pytest-dev/pytest/issues/3078&gt;`_: Remove legacy internal warnings system: ``config.warn``, ``Node.warn``. The ``pytest_logwarning`` now issues a warning when implemented.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlconfig-warn-and-node-warn&gt;`__ on information on how to update your code.


- `3079 &lt;https://github.com/pytest-dev/pytest/issues/3079&gt;`_: Removed support for yield tests - they are fundamentally broken because they don&#39;t support fixtures properly since collection and test execution were separated.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlyield-tests&gt;`__ on information on how to update your code.


- `3082 &lt;https://github.com/pytest-dev/pytest/issues/3082&gt;`_: Removed support for applying marks directly to values in ``pytest.mark.parametrize``. Use ``pytest.param`` instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlmarks-in-pytest-mark-parametrize&gt;`__ on information on how to update your code.


- `3083 &lt;https://github.com/pytest-dev/pytest/issues/3083&gt;`_: Removed ``Metafunc.addcall``. This was the predecessor mechanism to ``pytest.mark.parametrize``.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlmetafunc-addcall&gt;`__ on information on how to update your code.


- `3085 &lt;https://github.com/pytest-dev/pytest/issues/3085&gt;`_: Removed support for passing strings to ``pytest.main``. Now, always pass a list of strings instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpassing-command-line-string-to-pytest-main&gt;`__ on information on how to update your code.


- `3086 &lt;https://github.com/pytest-dev/pytest/issues/3086&gt;`_: ``[pytest]`` section in **setup.cfg** files is not longer supported, use ``[tool:pytest]`` instead. ``setup.cfg`` files
  are meant for use with ``distutils``, and a section named ``pytest`` has notoriously been a source of conflicts and bugs.

  Note that for **pytest.ini** and **tox.ini** files the section remains ``[pytest]``.


- `3616 &lt;https://github.com/pytest-dev/pytest/issues/3616&gt;`_: Removed the deprecated compat properties for ``node.Class/Function/Module`` - use ``pytest.Class/Function/Module`` now.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlinternal-classes-accessed-through-node&gt;`__ on information on how to update your code.


- `4421 &lt;https://github.com/pytest-dev/pytest/issues/4421&gt;`_: Removed the implementation of the ``pytest_namespace`` hook.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-namespace&gt;`__ on information on how to update your code.


- `4489 &lt;https://github.com/pytest-dev/pytest/issues/4489&gt;`_: Removed ``request.cached_setup``. This was the predecessor mechanism to modern fixtures.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlcached-setup&gt;`__ on information on how to update your code.


- `4535 &lt;https://github.com/pytest-dev/pytest/issues/4535&gt;`_: Removed the deprecated ``PyCollector.makeitem`` method. This method was made public by mistake a long time ago.


- `4543 &lt;https://github.com/pytest-dev/pytest/issues/4543&gt;`_: Removed support to define fixtures using the ``pytest_funcarg__`` prefix. Use the ``pytest.fixture`` decorator instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-funcarg-prefix&gt;`__ on information on how to update your code.


- `4545 &lt;https://github.com/pytest-dev/pytest/issues/4545&gt;`_: Calling fixtures directly is now always an error instead of a warning.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlcalling-fixtures-directly&gt;`__ on information on how to update your code.


- `4546 &lt;https://github.com/pytest-dev/pytest/issues/4546&gt;`_: Remove ``Node.get_marker(name)`` the return value was not usable for more than a existence check.

  Use ``Node.get_closest_marker(name)`` as a replacement.


- `4547 &lt;https://github.com/pytest-dev/pytest/issues/4547&gt;`_: The deprecated ``record_xml_property`` fixture has been removed, use the more generic ``record_property`` instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlrecord-xml-property&gt;`__ for more information.


- `4548 &lt;https://github.com/pytest-dev/pytest/issues/4548&gt;`_: An error is now raised if the ``pytest_plugins`` variable is defined in a non-top-level ``conftest.py`` file (i.e., not residing in the ``rootdir``).

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-plugins-in-non-top-level-conftest-files&gt;`__ for more information.


- `891 &lt;https://github.com/pytest-dev/pytest/issues/891&gt;`_: Remove ``testfunction.markername`` attributes - use ``Node.iter_markers(name=None)`` to iterate them.



Deprecations
------------

- `3050 &lt;https://github.com/pytest-dev/pytest/issues/3050&gt;`_: Deprecated the ``pytest.config`` global.

  See https://docs.pytest.org/en/latest/deprecations.htmlpytest-config-global for rationale.


- `3974 &lt;https://github.com/pytest-dev/pytest/issues/3974&gt;`_: Passing the ``message`` parameter of ``pytest.raises`` now issues a ``DeprecationWarning``.

  It is a common mistake to think this parameter will match the exception message, while in fact
  it only serves to provide a custom message in case the ``pytest.raises`` check fails. To avoid this
  mistake and because it is believed to be little used, pytest is deprecating it without providing
  an alternative for the moment.

  If you have concerns about this, please comment on `issue 3974 &lt;https://github.com/pytest-dev/pytest/issues/3974&gt;`__.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Deprecated ``raises(..., &#39;code(as_a_string)&#39;)`` and ``warns(..., &#39;code(as_a_string)&#39;)``.

  See https://docs.pytest.org/en/latest/deprecations.htmlraises-warns-exec for rationale and examples.



Features
--------

- `3191 &lt;https://github.com/pytest-dev/pytest/issues/3191&gt;`_: A warning is now issued when assertions are made for ``None``.

  This is a common source of confusion among new users, which write:

  .. code-block:: python

      assert mocked_object.assert_called_with(3, 4, 5, key=&quot;value&quot;)

  When they should write:

  .. code-block:: python

      mocked_object.assert_called_with(3, 4, 5, key=&quot;value&quot;)

  Because the ``assert_called_with`` method of mock objects already executes an assertion.

  This warning will not be issued when ``None`` is explicitly checked. An assertion like:

  .. code-block:: python

      assert variable is None

  will not issue the warning.


- `3632 &lt;https://github.com/pytest-dev/pytest/issues/3632&gt;`_: Richer equality comparison introspection on ``AssertionError`` for objects created using `attrs &lt;http://www.attrs.org/en/stable/&gt;`__ or `dataclasses &lt;https://docs.python.org/3/library/dataclasses.html&gt;`_ (Python 3.7+, `backported to 3.6 &lt;https://pypi.org/project/dataclasses&gt;`__).


- `4278 &lt;https://github.com/pytest-dev/pytest/issues/4278&gt;`_: ``CACHEDIR.TAG`` files are now created inside cache directories.

  Those files are part of the `Cache Directory Tagging Standard &lt;http://www.bford.info/cachedir/spec.html&gt;`__, and can
  be used by backup or synchronization programs to identify pytest&#39;s cache directory as such.


- `4292 &lt;https://github.com/pytest-dev/pytest/issues/4292&gt;`_: ``pytest.outcomes.Exit`` is derived from ``SystemExit`` instead of ``KeyboardInterrupt``. This allows us to better handle ``pdb`` exiting.


- `4371 &lt;https://github.com/pytest-dev/pytest/issues/4371&gt;`_: Updated the ``--collect-only`` option to display test descriptions when ran using ``--verbose``.


- `4386 &lt;https://github.com/pytest-dev/pytest/issues/4386&gt;`_: Restructured ``ExceptionInfo`` object construction and ensure incomplete instances have a ``repr``/``str``.


- `4416 &lt;https://github.com/pytest-dev/pytest/issues/4416&gt;`_: pdb: added support for keyword arguments with ``pdb.set_trace``.

  It handles ``header`` similar to Python 3.7 does it, and forwards any
  other keyword arguments to the ``Pdb`` constructor.

  This allows for ``__import__(&quot;pdb&quot;).set_trace(skip=[&quot;foo.*&quot;])``.


- `4483 &lt;https://github.com/pytest-dev/pytest/issues/4483&gt;`_: Added ini parameter ``junit_duration_report`` to optionally report test call durations, excluding setup and teardown times.

  The JUnit XML specification and the default pytest behavior is to include setup and teardown times in the test duration
  report. You can include just the call durations instead (excluding setup and teardown) by adding this to your ``pytest.ini`` file:

  .. code-block:: ini

      [pytest]
      junit_duration_report = call


- `4532 &lt;https://github.com/pytest-dev/pytest/issues/4532&gt;`_: ``-ra`` now will show errors and failures last, instead of as the first items in the summary.

  This makes it easier to obtain a list of errors and failures to run tests selectively.


- `4599 &lt;https://github.com/pytest-dev/pytest/issues/4599&gt;`_: ``pytest.importorskip`` now supports a ``reason`` parameter, which will be shown when the
  requested module cannot be imported.



Bug Fixes
---------

- `3532 &lt;https://github.com/pytest-dev/pytest/issues/3532&gt;`_: ``-p`` now accepts its argument without a space between the value, for example ``-pmyplugin``.


- `4327 &lt;https://github.com/pytest-dev/pytest/issues/4327&gt;`_: ``approx`` again works with more generic containers, more precisely instances of ``Iterable`` and ``Sized`` instead of more restrictive ``Sequence``.


- `4397 &lt;https://github.com/pytest-dev/pytest/issues/4397&gt;`_: Ensure that node ids are printable.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Fixed ``raises(..., &#39;code(string)&#39;)`` frame filename.


- `4458 &lt;https://github.com/pytest-dev/pytest/issues/4458&gt;`_: Display actual test ids in ``--collect-only``.



Improved Documentation
----------------------

- `4557 &lt;https://github.com/pytest-dev/pytest/issues/4557&gt;`_: Markers example documentation page updated to support latest pytest version.


- `4558 &lt;https://github.com/pytest-dev/pytest/issues/4558&gt;`_: Update cache documentation example to correctly show cache hit and miss.


- `4580 &lt;https://github.com/pytest-dev/pytest/issues/4580&gt;`_: Improved detailed summary report documentation.



Trivial/Internal Changes
------------------------

- `4447 &lt;https://github.com/pytest-dev/pytest/issues/4447&gt;`_: Changed the deprecation type of ``--result-log`` to ``PytestDeprecationWarning``.

  It was decided to remove this feature at the next major revision.
   ```
   
  
  
   ### 4.0.2
   ```
   =========================

Bug Fixes
---------

- `4265 &lt;https://github.com/pytest-dev/pytest/issues/4265&gt;`_: Validate arguments from the ``PYTEST_ADDOPTS`` environment variable and the ``addopts`` ini option separately.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Fix ``raises(..., &#39;code(string)&#39;)`` frame filename.


- `4500 &lt;https://github.com/pytest-dev/pytest/issues/4500&gt;`_: When a fixture yields and a log call is made after the test runs, and, if the test is interrupted, capture attributes are ``None``.


- `4538 &lt;https://github.com/pytest-dev/pytest/issues/4538&gt;`_: Raise ``TypeError`` for ``with raises(..., match=&lt;non-None falsey value&gt;)``.



Improved Documentation
----------------------

- `1495 &lt;https://github.com/pytest-dev/pytest/issues/1495&gt;`_: Document common doctest fixture directory tree structure pitfalls
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pytest
  - Changelog: https://pyup.io/changelogs/pytest/
  - Homepage: https://docs.pytest.org/en/latest/
</details>





### Update [raven](https://pypi.org/project/raven) from **6.9.0** to **6.10.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 6.10.0
   ```
   ------

* [Core] Fixed stackframes in some situations being in inverse order.
* [Flask] Fix wrong exception handling logic (accidentally relied on Flask internals).
* [Core] No longer send NaN local vars as non-standard JSON.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/raven
  - Changelog: https://pyup.io/changelogs/raven/
  - Repo: https://github.com/getsentry/raven-python
</details>





### Update [backoff](https://pypi.org/project/backoff) from **1.7.1** to **1.8.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.8.0
   ```
   Changed

- Give up on StopIteration raised in wait generators
- Iterable intervals for constant wait_gen for predefined wait sequences
- Nullary jitter signature deprecation warning
- Custom loggers
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/backoff
  - Changelog: https://pyup.io/changelogs/backoff/
  - Repo: https://github.com/litl/backoff
</details>





### Update [google-cloud-storage](https://pypi.org/project/google-cloud-storage) from **1.13.0** to **1.13.2**.


*The bot wasn't able to find a changelog for this release. [Got an idea?](https://github.com/pyupio/changelogs/issues/new)*

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/google-cloud-storage
  - Repo: https://github.com/GoogleCloudPlatform/google-cloud-python
</details>





### Update [kinto-http](https://pypi.org/project/kinto-http) from **10.1.0** to **10.2.0**.


<details>
  <summary>Changelog</summary>
  
  
   ### 10.2.0
   ```
   ===================

**New features**

- Created new method on client to get paginated records ``get_paginated_records``. (175)
- Allow additional querystring params in `get_*()` methods
   ```
   
  
  
   ### 10.1.1
   ```
   ===================

**Bug fixes**

- Fix JSON support for `in_` and `exclude_`. (188)
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/kinto-http
  - Changelog: https://pyup.io/changelogs/kinto-http/
  - Repo: https://github.com/Kinto/kinto-http.py/
</details>





### Update [Sphinx](https://pypi.org/project/Sphinx) from **1.8.2** to **1.8.3**.


<details>
  <summary>Changelog</summary>
  
  
   ### 1.8.3
   ```
   ==============================

Dependencies
------------

Incompatible changes
--------------------

Deprecated
----------

Features added
--------------

* LaTeX: it is possible to insert custom material to appear on back of title
  page, see discussion of ``&#39;maketitle&#39;`` key of :confval:`latex_elements`
  (``&#39;manual&#39;`` docclass only)

Bugs fixed
----------

* 5725: mathjax: Use CDN URL for &quot;latest&quot; version by default
* 5460: html search does not work with some 3rd party themes
* 5520: LaTeX, caption package incompatibility since Sphinx 1.6
* 5614: autodoc: incremental build is broken when builtin modules are imported
* 5627: qthelp: index.html missing in QtHelp
* 5659: linkcheck: crashes for a hyperlink containing multibyte character
* 5754: DOC: Fix some mistakes in :doc:`/latex`
* 5810: LaTeX: sphinxVerbatim requires explicit &quot;hllines&quot; set-up since 1.6.6
  (refs: 1238)
* 5636: C++, fix parsing of floating point literals.
* 5496 (again): C++, fix assertion in partial builds with duplicates.
* 5724: quickstart: sphinx-quickstart fails when $LC_ALL is empty
* 1956: Default conf.py is not PEP8-compliant
* 5849: LaTeX: document class ``\maketitle`` is overwritten with no
  possibility to use original meaning in place of Sphinx custom one
* 5834: apidoc: wrong help for ``--tocfile``
* 5800: todo: crashed if todo is defined in TextElement
* 5846: htmlhelp: convert hex escaping to decimal escaping in .hhc/.hhk files

Testing
--------
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/sphinx
  - Changelog: https://pyup.io/changelogs/sphinx/
  - Homepage: http://sphinx-doc.org/
</details>







Co-authored-by: pyup-bot <github-bot@pyup.io>
Co-authored-by: Peter Bengtsson <mail@peterbe.com>

bors bot added a commit to rehandalal/therapist that referenced this pull request Jan 13, 2019

Merge #54
54: Update pytest to 4.1.1 r=rehandalal a=pyup-bot


This PR updates [pytest](https://pypi.org/project/pytest) from **4.0.2** to **4.1.1**.



<details>
  <summary>Changelog</summary>
  
  
   ### 4.1.1
   ```
   =========================

Bug Fixes
---------

- `2256 &lt;https://github.com/pytest-dev/pytest/issues/2256&gt;`_: Show full repr with ``assert a==b`` and ``-vv``.


- `3456 &lt;https://github.com/pytest-dev/pytest/issues/3456&gt;`_: Extend Doctest-modules to ignore mock objects.


- `4617 &lt;https://github.com/pytest-dev/pytest/issues/4617&gt;`_: Fixed ``pytest.warns`` bug when context manager is reused (e.g. multiple parametrization).


- `4631 &lt;https://github.com/pytest-dev/pytest/issues/4631&gt;`_: Don&#39;t rewrite assertion when ``__getattr__`` is broken



Improved Documentation
----------------------

- `3375 &lt;https://github.com/pytest-dev/pytest/issues/3375&gt;`_: Document that using ``setup.cfg`` may crash other tools or cause hard to track down problems because it uses a different parser than ``pytest.ini`` or ``tox.ini`` files.



Trivial/Internal Changes
------------------------

- `4602 &lt;https://github.com/pytest-dev/pytest/issues/4602&gt;`_: Uninstall ``hypothesis`` in regen tox env.
   ```
   
  
  
   ### 4.1.0
   ```
   =========================

Removals
--------

- `2169 &lt;https://github.com/pytest-dev/pytest/issues/2169&gt;`_: ``pytest.mark.parametrize``: in previous versions, errors raised by id functions were suppressed and changed into warnings. Now the exceptions are propagated, along with a pytest message informing the node, parameter value and index where the exception occurred.


- `3078 &lt;https://github.com/pytest-dev/pytest/issues/3078&gt;`_: Remove legacy internal warnings system: ``config.warn``, ``Node.warn``. The ``pytest_logwarning`` now issues a warning when implemented.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlconfig-warn-and-node-warn&gt;`__ on information on how to update your code.


- `3079 &lt;https://github.com/pytest-dev/pytest/issues/3079&gt;`_: Removed support for yield tests - they are fundamentally broken because they don&#39;t support fixtures properly since collection and test execution were separated.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlyield-tests&gt;`__ on information on how to update your code.


- `3082 &lt;https://github.com/pytest-dev/pytest/issues/3082&gt;`_: Removed support for applying marks directly to values in ``pytest.mark.parametrize``. Use ``pytest.param`` instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlmarks-in-pytest-mark-parametrize&gt;`__ on information on how to update your code.


- `3083 &lt;https://github.com/pytest-dev/pytest/issues/3083&gt;`_: Removed ``Metafunc.addcall``. This was the predecessor mechanism to ``pytest.mark.parametrize``.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlmetafunc-addcall&gt;`__ on information on how to update your code.


- `3085 &lt;https://github.com/pytest-dev/pytest/issues/3085&gt;`_: Removed support for passing strings to ``pytest.main``. Now, always pass a list of strings instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpassing-command-line-string-to-pytest-main&gt;`__ on information on how to update your code.


- `3086 &lt;https://github.com/pytest-dev/pytest/issues/3086&gt;`_: ``[pytest]`` section in **setup.cfg** files is not longer supported, use ``[tool:pytest]`` instead. ``setup.cfg`` files
  are meant for use with ``distutils``, and a section named ``pytest`` has notoriously been a source of conflicts and bugs.

  Note that for **pytest.ini** and **tox.ini** files the section remains ``[pytest]``.


- `3616 &lt;https://github.com/pytest-dev/pytest/issues/3616&gt;`_: Removed the deprecated compat properties for ``node.Class/Function/Module`` - use ``pytest.Class/Function/Module`` now.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlinternal-classes-accessed-through-node&gt;`__ on information on how to update your code.


- `4421 &lt;https://github.com/pytest-dev/pytest/issues/4421&gt;`_: Removed the implementation of the ``pytest_namespace`` hook.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-namespace&gt;`__ on information on how to update your code.


- `4489 &lt;https://github.com/pytest-dev/pytest/issues/4489&gt;`_: Removed ``request.cached_setup``. This was the predecessor mechanism to modern fixtures.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlcached-setup&gt;`__ on information on how to update your code.


- `4535 &lt;https://github.com/pytest-dev/pytest/issues/4535&gt;`_: Removed the deprecated ``PyCollector.makeitem`` method. This method was made public by mistake a long time ago.


- `4543 &lt;https://github.com/pytest-dev/pytest/issues/4543&gt;`_: Removed support to define fixtures using the ``pytest_funcarg__`` prefix. Use the ``pytest.fixture`` decorator instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-funcarg-prefix&gt;`__ on information on how to update your code.


- `4545 &lt;https://github.com/pytest-dev/pytest/issues/4545&gt;`_: Calling fixtures directly is now always an error instead of a warning.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlcalling-fixtures-directly&gt;`__ on information on how to update your code.


- `4546 &lt;https://github.com/pytest-dev/pytest/issues/4546&gt;`_: Remove ``Node.get_marker(name)`` the return value was not usable for more than a existence check.

  Use ``Node.get_closest_marker(name)`` as a replacement.


- `4547 &lt;https://github.com/pytest-dev/pytest/issues/4547&gt;`_: The deprecated ``record_xml_property`` fixture has been removed, use the more generic ``record_property`` instead.

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlrecord-xml-property&gt;`__ for more information.


- `4548 &lt;https://github.com/pytest-dev/pytest/issues/4548&gt;`_: An error is now raised if the ``pytest_plugins`` variable is defined in a non-top-level ``conftest.py`` file (i.e., not residing in the ``rootdir``).

  See our `docs &lt;https://docs.pytest.org/en/latest/deprecations.htmlpytest-plugins-in-non-top-level-conftest-files&gt;`__ for more information.


- `891 &lt;https://github.com/pytest-dev/pytest/issues/891&gt;`_: Remove ``testfunction.markername`` attributes - use ``Node.iter_markers(name=None)`` to iterate them.



Deprecations
------------

- `3050 &lt;https://github.com/pytest-dev/pytest/issues/3050&gt;`_: Deprecated the ``pytest.config`` global.

  See https://docs.pytest.org/en/latest/deprecations.htmlpytest-config-global for rationale.


- `3974 &lt;https://github.com/pytest-dev/pytest/issues/3974&gt;`_: Passing the ``message`` parameter of ``pytest.raises`` now issues a ``DeprecationWarning``.

  It is a common mistake to think this parameter will match the exception message, while in fact
  it only serves to provide a custom message in case the ``pytest.raises`` check fails. To avoid this
  mistake and because it is believed to be little used, pytest is deprecating it without providing
  an alternative for the moment.

  If you have concerns about this, please comment on `issue 3974 &lt;https://github.com/pytest-dev/pytest/issues/3974&gt;`__.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Deprecated ``raises(..., &#39;code(as_a_string)&#39;)`` and ``warns(..., &#39;code(as_a_string)&#39;)``.

  See https://docs.pytest.org/en/latest/deprecations.htmlraises-warns-exec for rationale and examples.



Features
--------

- `3191 &lt;https://github.com/pytest-dev/pytest/issues/3191&gt;`_: A warning is now issued when assertions are made for ``None``.

  This is a common source of confusion among new users, which write:

  .. code-block:: python

      assert mocked_object.assert_called_with(3, 4, 5, key=&quot;value&quot;)

  When they should write:

  .. code-block:: python

      mocked_object.assert_called_with(3, 4, 5, key=&quot;value&quot;)

  Because the ``assert_called_with`` method of mock objects already executes an assertion.

  This warning will not be issued when ``None`` is explicitly checked. An assertion like:

  .. code-block:: python

      assert variable is None

  will not issue the warning.


- `3632 &lt;https://github.com/pytest-dev/pytest/issues/3632&gt;`_: Richer equality comparison introspection on ``AssertionError`` for objects created using `attrs &lt;http://www.attrs.org/en/stable/&gt;`__ or `dataclasses &lt;https://docs.python.org/3/library/dataclasses.html&gt;`_ (Python 3.7+, `backported to 3.6 &lt;https://pypi.org/project/dataclasses&gt;`__).


- `4278 &lt;https://github.com/pytest-dev/pytest/issues/4278&gt;`_: ``CACHEDIR.TAG`` files are now created inside cache directories.

  Those files are part of the `Cache Directory Tagging Standard &lt;http://www.bford.info/cachedir/spec.html&gt;`__, and can
  be used by backup or synchronization programs to identify pytest&#39;s cache directory as such.


- `4292 &lt;https://github.com/pytest-dev/pytest/issues/4292&gt;`_: ``pytest.outcomes.Exit`` is derived from ``SystemExit`` instead of ``KeyboardInterrupt``. This allows us to better handle ``pdb`` exiting.


- `4371 &lt;https://github.com/pytest-dev/pytest/issues/4371&gt;`_: Updated the ``--collect-only`` option to display test descriptions when ran using ``--verbose``.


- `4386 &lt;https://github.com/pytest-dev/pytest/issues/4386&gt;`_: Restructured ``ExceptionInfo`` object construction and ensure incomplete instances have a ``repr``/``str``.


- `4416 &lt;https://github.com/pytest-dev/pytest/issues/4416&gt;`_: pdb: added support for keyword arguments with ``pdb.set_trace``.

  It handles ``header`` similar to Python 3.7 does it, and forwards any
  other keyword arguments to the ``Pdb`` constructor.

  This allows for ``__import__(&quot;pdb&quot;).set_trace(skip=[&quot;foo.*&quot;])``.


- `4483 &lt;https://github.com/pytest-dev/pytest/issues/4483&gt;`_: Added ini parameter ``junit_duration_report`` to optionally report test call durations, excluding setup and teardown times.

  The JUnit XML specification and the default pytest behavior is to include setup and teardown times in the test duration
  report. You can include just the call durations instead (excluding setup and teardown) by adding this to your ``pytest.ini`` file:

  .. code-block:: ini

      [pytest]
      junit_duration_report = call


- `4532 &lt;https://github.com/pytest-dev/pytest/issues/4532&gt;`_: ``-ra`` now will show errors and failures last, instead of as the first items in the summary.

  This makes it easier to obtain a list of errors and failures to run tests selectively.


- `4599 &lt;https://github.com/pytest-dev/pytest/issues/4599&gt;`_: ``pytest.importorskip`` now supports a ``reason`` parameter, which will be shown when the
  requested module cannot be imported.



Bug Fixes
---------

- `3532 &lt;https://github.com/pytest-dev/pytest/issues/3532&gt;`_: ``-p`` now accepts its argument without a space between the value, for example ``-pmyplugin``.


- `4327 &lt;https://github.com/pytest-dev/pytest/issues/4327&gt;`_: ``approx`` again works with more generic containers, more precisely instances of ``Iterable`` and ``Sized`` instead of more restrictive ``Sequence``.


- `4397 &lt;https://github.com/pytest-dev/pytest/issues/4397&gt;`_: Ensure that node ids are printable.


- `4435 &lt;https://github.com/pytest-dev/pytest/issues/4435&gt;`_: Fixed ``raises(..., &#39;code(string)&#39;)`` frame filename.


- `4458 &lt;https://github.com/pytest-dev/pytest/issues/4458&gt;`_: Display actual test ids in ``--collect-only``.



Improved Documentation
----------------------

- `4557 &lt;https://github.com/pytest-dev/pytest/issues/4557&gt;`_: Markers example documentation page updated to support latest pytest version.


- `4558 &lt;https://github.com/pytest-dev/pytest/issues/4558&gt;`_: Update cache documentation example to correctly show cache hit and miss.


- `4580 &lt;https://github.com/pytest-dev/pytest/issues/4580&gt;`_: Improved detailed summary report documentation.



Trivial/Internal Changes
------------------------

- `4447 &lt;https://github.com/pytest-dev/pytest/issues/4447&gt;`_: Changed the deprecation type of ``--result-log`` to ``PytestDeprecationWarning``.

  It was decided to remove this feature at the next major revision.
   ```
   
  
</details>


 

<details>
  <summary>Links</summary>
  
  - PyPI: https://pypi.org/project/pytest
  - Changelog: https://pyup.io/changelogs/pytest/
  - Homepage: https://docs.pytest.org/en/latest/
</details>



Co-authored-by: pyup-bot <github-bot@pyup.io>
Sign up for free to join this conversation on GitHub. Already have an account? Sign in to comment